/*****************************************************************************
 * $RCSfile: BallMessage.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 *
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: fastjack $
 * $Date: 2002/04/15 03:24:20 $
 * $Revision: 1.1 $
 *****************************************************************************/


#ifndef _BALLMESSAGE_HH
#define _BALLMESSAGE_HH

class BallMessage {

  static int base64chartoint( char ch );
  static char itobase64char( int value );
  static void itobase64( int value, char *str );
  static int base64fromstr( char * str );


  char * str;
  float x;
  float y;
  float conf;
  float vx;
  float vy;
  float vconf;
  float dist;

  static void parseBallMessage( char * str,
                                float & ballX,
                                float & ballY,
                                float & ballConf,
                                float & ballVelX,
                                float & ballVelY,
                                float & ballVelConf,
                                float & ballDist);

public:

  const static char IDENTIFIER = 'B';

  BallMessage( float x,
               float y,
               float conf,
               float vx,
               float vy,
               float vconf,
               float dist );

  BallMessage( char * str );

  float getX() { return x; }
  float getY() { return y; }
  float getConf() { return conf; }
  float getVelX() { return vx; }
  float getVelY() { return vy; }
  float getVelConf() { return vconf; }
  float getDist() { return dist; }
  char * getCharString() { return str; }

  static int test() {
    int errors = 0;
    if (!testParseBallMessage()) errors++;
    if (!testConversionUtilities()) errors++;
    return errors;
  }

  static bool testParseBallMessage();
  static bool testConversionUtilities();
};

#endif

/*
 * $Log: BallMessage.hh,v $
 * Revision 1.1  2002/04/15 03:24:20  fastjack
 * BallMessage Klasse fr das Parsen/Generieren von BallInfos gebaut. CommunicationManager aufgerumt.
 *
 */
