/*****************************************************************************
 * $RCSfile: InitPotentialLoader.cpp,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: fastjack $
 * $Date: 2002/03/01 11:18:46 $
 * $Revision: 1.6 $
 *****************************************************************************
----------------------------------------------------------------
  Projekt : Robocup
  Jens Meyer, Matthias Seekamp, Volker Weilandt, Daniel
  Stephan, Robert, Andreas Daniel

  class InitpotentialLoader
  wird aufgerufen, wenn der Player
  initialisert werden soll.
  Mit readPotentialFile(string)  wird der Einlese
  vorgang eingeleitet.
  Dann werden die Parameter gesetzt.



  InitPotentialLaoader : Eingefhrt an 25.12.2001
  Status               : develop
  Stand                : Kann PotentialWerte einlesen
                         und Paramter im Potentialfeld setzen.
  Wunsch               : ?


-------------------------------------------------------------------
*/


#include "initpotentialloader.h"
#include "PotentialField.hh"

#define BUFFER 128 // Zeilenlaenge

// TestMethode
void InitPotentialLoader :: default_setBallPriority(int value) {

;  // cout << "Setze Wert default_BallPriority " << value << " ...." << endl;
}

int InitPotentialLoader :: getValue_Init(const char* value_string) {
   char buffer_init [128];
   for (int i=0; i < 126; i++) {
     buffer_init[i] = value_string[i+2];
   }

   return atoi(buffer_init);

}

void InitPotentialLoader :: readPotentialFile(const char* file,PotentialField * pf) {
  cout << "Initialize Player...";
  cout << "Reading File: " << file << endl;

  // Ueberprfen , ob die Datei existiert
  ifstream ifs (file, ios::in);

  if (!ifs) {

    cout << "Error : Unable to open File : " << file << endl;;
    exit (1);
  }


  bool twiceflag [5] [5];
  for (int i=0; i < 5;i++) {

    for (int d=0;d < 5;d++) {

    twiceflag [i] [d] = false;

    }
  }



  // Einlesen der Datei Zeile fr Zeile





  char buffer [BUFFER];
  int a;
  while (!ifs.eof()) {

   ifs.getline(buffer, sizeof(buffer), '\n');
   a = setInstructionValues_Init(buffer, pf);

   if ( a > -1 && a < 6 ) {

     if (twiceflag [0] [a] == false) {
       twiceflag [0] [a] = true;
     }
     else
       {
	 cout << "Achtung : Doppelte Parameterinitialisierung in der Initialisierungsdatei ! Abbruch..." << endl;exit(1);
	   }

     }
    if ( a > 9 && a < 16 ) {

    if (twiceflag [1] [a-10] == false) {
       twiceflag [1] [a-10] = true;
     }
     else
       {
	 cout << "Achtung : Doppelte Parameterinitialisierung in der Initialisierungsdatei ! Abbruch ..." << endl;exit(1);
	   }

     }
     if ( a > 19 && a < 26 ) {

     if (twiceflag [2] [a-20] == false) {
       twiceflag [2] [a-20] = true;
     }
     else
       {
	 cout << "Achtung : Doppelte Parameterinitialisierung in der Initialisierungsdatei ! Abbruch ..." << endl;exit(1);
	   }

     }
     if ( a > 29 && a < 36 ) {

     if (twiceflag [3] [a-30] == false) {
       twiceflag [3] [a-30] = true;
     }
     else
       {
	 cout << "Achtung : Doppelte Parameterinitialisierung in der Initialisierungsdatei ! Abbruch ..." << endl;exit(1);
	   }

     }
     if ( a > 39 && a < 46 ) {

     if (twiceflag [4] [a-40] == false) {
       twiceflag [4] [a-40] = true;
     }
     else
       {
	 cout << "Achtung : Doppelte Parameterinitialisierung in der Initialisierungsdatei ! Abbruch ..." << endl;exit (1);
	   }

     }

  }
  cout << "Initializing successfully..." << endl;
}




int InitPotentialLoader :: setInstructionValues_Init(const char* value,PotentialField * pf) {
  switch (value[0])

    {

    case 'a' :
      {
        switch(value[1])
	
	  {
	
	  case 'v' : pf -> changeStaminaprioritaet(getValue_Init(value)); return 0;
	  case 'w' : pf -> changeTorschussbewertung(getValue_Init(value)); return 1;
	  case 'x' : pf -> changeTorschussprioritaet(getValue_Init(value)); return 2;
	  case 'y' : pf -> changeRueckpasspriority(getValue_Init(value)); return 3;
	  case 'z' : pf -> changeEntfernungswert(getValue_Init(value)); return 4;

	  default : cout << "Ungltige Zeichenkette in Initialisierungsdatei im aParameter ! Abbruch ..."  << endl; exit(1);
	
	  }
	
      }

    case 'b' :
      {
	
	switch (value[1])
	  {
	
	  case 'v' :  pf -> changeEntfernungsprioritaet(getValue_Init(value));return 10;
	  case 'w' :  pf -> changeBallbewertung(getValue_Init(value));return 11;
	  case 'x' :  pf -> changeBallpriority(getValue_Init(value)); return 12;
	  case 'y' :  pf -> changeTaktik(getValue_Init(value)); return 13;
	  case 'z' :  pf -> changeSelfGrundX(getValue_Init(value)); return 14;
	  default : cout << "Ungueltige Zeichenkette in Initialiserungsdatei im bParameter ! Abbruch ..." << endl;exit(1);
	  }
	
      }


    case 'c' :
      {
	switch (value[1])
	  {
	
	  case 'v' : pf -> changeSelfGrundY(getValue_Init(value)); return 20;
	  case 'w' : pf -> changePositionsprioritaet(getValue_Init(value)); return 21;
	  case 'x' : pf -> changeGegnerprioritaetMitBall(getValue_Init(value)); return 22;
	  case 'y' : pf -> changeGegnerprioritaetOhneBall(getValue_Init(value)); return 23;
	  case 'z' : pf -> changeMitspielerprioritaetMitBall(getValue_Init(value)); return 24;
	  default : cout << "Ungueltige Zeichenkette in Initialiserungsdatei im cParameter! Abbruch ..." << endl;exit(1);
	
	  }
	
      }

     case 'd' :

       {
	 switch (value[1])
	   {
	
	   case 'v' : pf -> changeMitspielerprioritaetOhneBall(getValue_Init(value)); return 30;
	   case 'w' : pf -> changeMitspielerprioritaetTeammateMitBall(getValue_Init(value)); return 31;
	   case 'x' : pf -> changeMyMannschaftsteil(getValue_Init(value)); return 32;
	   case 'y' : default_setBallPriority(getValue_Init(value)); return 33;
	   case 'z' : default_setBallPriority(getValue_Init(value)); return 34;
	   default : cout << "Ungueltige Zeichenkette Initialisierungsdatei im dParameter! Abbruch ..." << endl;exit(1);
	
           }
	
	
       }

    case 'e' :
      {
	switch (value[1])
	  {
	
	  case 'v' : default_setBallPriority(getValue_Init(value)); return 40;
	  case 'w' : default_setBallPriority(getValue_Init(value)); return 41;
	  case 'x' : default_setBallPriority(getValue_Init(value)); return 42;
	  case 'y' : default_setBallPriority(getValue_Init(value)); return 43;
	  case 'z' : default_setBallPriority(getValue_Init(value)); return 44;
	  default : cout << "Ungueltige Zeichenkette in Initialisierungsdatei im eParameter ! Abbruch ..." << endl; exit(1);
	
	  }
	
	
	
      }

    case '/' : return 99;

    case '\n' : return 99;

    case '\0' : return 99;	  // Wenn nichts mehr hilft

    case '\r' : return 99;

    case ' ' : return 99;

    default : {
      cout << "Ungueltige Zeichenkette in Initialisierungsdatei : " << value << " Abbruch ..." << endl;exit(1);
    }



    }


  return 99; // damit der compiler nicht meckert. hier sollte er eh nie hinkommen.

}




/*
 * $Log: InitPotentialLoader.cpp,v $
 * Revision 1.6  2002/03/01 11:18:46  fastjack
 * GPL added
 *
 * Revision 1.5  2002/02/10 12:19:13  fastjack
 * Habe die Includes angepasst, damit die Header sich so wenig wie mglich
 * gegenseitig includen. Z.T. ersetzt durch forward Deklaration. getPFEntry Methode
 * aus dem PotentialField heraus geholt und in den PFieldLogger gepackt - ist dort
 * sinniger.
 *
 * Revision 1.4  2002/01/29 09:23:47  fastjack
 * Aufgeraeumt und Warning beseitigt.
 *
 * Revision 1.3  2002/01/28 17:22:03  seekamp
 * Dem Torwart Abschlaege und Abstoesse beigebracht
 *
 * Revision 1.2  2002/01/18 19:49:29  seekamp
 * Prioritaeten werden durch Andys FileReader aus individuellen Spielertextdateien eingelesen.
 *
 */


