/* -*- Mode: C++ -*- */

/*****************************************************************************
 * $RCSfile: Log.cc,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Class provides a method to print a log message to the console
 * with certain additional information.
 *
 * Last changed:
 * ------------------------------
 * $Author: fastjack $
 * $Date: 2002/03/01 11:18:46 $
 * $Revision: 1.5 $
 *****************************************************************************/

#include "Log.hh"

Log Log::info;
Log Log::warn;
Log Log::debug;

Log::Log() {
  os = &std::cout;
  active = true;
  devnull.open("/dev/null");
}
Log::~Log() {
  devnull.close();
}


std::ostream & Log::operator<<(char *v) {
  if (!active) {
    return devnull;
  }
  
  cout << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return cout;
}

std::ostream & Log::operator<<(int v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(double v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(float v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(char v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(long v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(long double v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(unsigned int v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}

std::ostream & Log::operator<<(unsigned long v) {
  if (!active) {
    return devnull;
  }
  
  (*os) << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) 
     << ":" << cmu::Mem->MyNumber << "] " << v;
  return (*os);
}


/*
 * $Log: Log.cc,v $
 * Revision 1.5  2002/03/01 11:18:46  fastjack
 * GPL added
 *
 * Revision 1.4  2002/01/25 17:22:32  fastjack
 * compiles under Linux AND Solaris8 now. so can be run on the sxx machines now.
 *
 * Revision 1.3  2002/01/15 16:33:42  fastjack
 * Neue features fuer die Log-Klasse (kann jetzt wie cout etc verwendet werden), und kleinere Verbesserungen fuer den PFieldLogger hinzugefuegt.
 *
 * Revision 1.2  2002/01/15 12:13:04  fastjack
 * Log compiled
 *
 * Revision 1.1  2002/01/03 01:10:16  fastjack
 * fr intelligentere Log ausgaben erzeugte Klasse Log.
 *
 */
