/* -*- Mode: C++ -*- */

/*****************************************************************************
 * $RCSfile: Log.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Class provides a method to print a log message to the console
 * with certain additional information.
 *
 * Last changed:
 * ------------------------------
 * $Author: fastjack $
 * $Date: 2002/03/01 11:18:46 $
 * $Revision: 1.7 $
 *****************************************************************************/

#ifndef _LOG_HH_
#define _LOG_HH_

#include "client.h"
#include <iostream>
#include <fstream>

class Log {

  bool active;
  std::ostream * os;
  std::ofstream devnull;

  public:
  static Log debug;
  static Log info;
  static Log warn;
  
  static void print(char * message)
  {  
    cout << "[" << (cmu::Mem->CurrentTime.t+cmu::Mem->CurrentTime.s) << ":" 
	 << cmu::Mem->MyNumber << "] " << message << endl;
  };

  Log();
  virtual ~Log();
  
  std::ostream & operator<<(char *v);
  std::ostream & operator<<(int v);
  std::ostream & operator<<(double v);
  std::ostream & operator<<(float v);
  std::ostream & operator<<(char v);
  std::ostream & operator<<(long v);
  std::ostream & operator<<(long double v);
  std::ostream & operator<<(unsigned int v);
  std::ostream & operator<<(unsigned long v);

  void disable() {
    active = false;
  }
  void enable() {
    active = true;
  }
  
  
};


/*
 * $Log: Log.hh,v $
 * Revision 1.7  2002/03/01 11:18:46  fastjack
 * GPL added
 *
 * Revision 1.6  2002/01/25 17:22:33  fastjack
 * compiles under Linux AND Solaris8 now. so can be run on the sxx machines now.
 *
 * Revision 1.5  2002/01/18 20:11:20  fastjack
 * Das Logging von Potentialfeldern fertig gestellt. Das Logging ist auch
 * ein-/ausschaltbar ( PFieldLogger::getInstance().setEnabled(true) ).
 *
 * Revision 1.4  2002/01/15 16:33:43  fastjack
 * Neue features fuer die Log-Klasse (kann jetzt wie cout etc verwendet werden), und kleinere Verbesserungen fuer den PFieldLogger hinzugefuegt.
 *
 * Revision 1.3  2002/01/15 12:13:04  fastjack
 * Log compiled
 *
 * Revision 1.2  2002/01/03 17:48:02  fastjack
 * einige abstuerze behoben.
 *
 * Revision 1.1  2002/01/03 01:10:17  fastjack
 * fr intelligentere Log ausgaben erzeugte Klasse Log.
 *
 */

#endif

