/*****************************************************************************
 * $RCSfile: OffensiveMoveBehaviour.cc,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 *
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: jens $
 * $Date: 2002/04/13 07:59:17 $
 * $Revision: 1.8 $
 *
 *****************************************************************************/

#include "OffensiveMoveBehaviour.hh"
#include "client.h"
#include "mybehave.h"
#include "world.hh"


float OffensiveMoveBehaviour::goalie_x()
{
  
  float goalie = 0.0;
  cmu::PlayerObject * tempPlayer;
  
  
  for (int i=0; i<cmu::Mem->NumOpponents();i++) 
    {
      tempPlayer = cmu::Mem->Opponents()[i];
      
      if ((tempPlayer != NULL) &&
	  (tempPlayer->pos_valid())) {
	if (tempPlayer->get_abs_pos().x > cmu::Mem->BallX())
	  {
	    if (tempPlayer->get_abs_pos().x > goalie)
	      {
		goalie = tempPlayer->get_abs_pos().x;
	      }
	  }
      }
    }
  



  return goalie;
}







bool OffensiveMoveBehaviour::isSituation() {

  bool res = ( ( cmu::Mem->MyNumber != 1 ) &&
	       ( cmu::Mem->MyX() < 40 ) && ( cmu::Mem->MyX() > 5 ) &&
	       /* (!isTeammateCloserToTheirGoal()) && */ (cmu::Mem->PlayMode ==  cmu::PM_Play_On) &&
	       ( cmu::Mem->BallDistance() < 5 ) &&
	       ( cmu::Mem->NumOpponentsInCone( 0.7, cmu::Vector ( cmu::Mem->MyX()+7, cmu::Mem->MyY() + 0.4 *  (0-cmu::Mem->MyY()) ) ) == 0 ) );

	       //  ( cmu::Mem->MyPos().dist( cmu::Mem->BallAbsolutePosition() ) < 2 ) &&
	       //  ( cmu::Mem->NumTeammatesInCone( 3, cmu::Vector ( cmu::Mem->MyX()+45, cmu::Mem->MyY() ) ) == 0 ) && 
	       //  ( cmu::Mem->PlayMode == cmu::PM_Play_On ) &&
	       //  ( cmu::Mem->NumOpponentsInCone( 0.7, cmu::Vector ( cmu::Mem->MyX()+5, cmu::Mem->MyY() ) ) == 0 ) );
  

  if (!res) getball = false;
  
  return res;

}

int OffensiveMoveBehaviour::numberOfOpponentsInRange(float dist){
  int result = 0;
  for (int i=1; i<=cmu::Mem->SP_team_size; i++){
    if ( cmu::Mem->OpponentPositionValid(i) &&
	 cmu::Mem->OpponentDistance(i) <= (dist + FLOAT_EPS) )
      result++;
  }
  return result;
}

void OffensiveMoveBehaviour::dribbleTo( const cmu::Vector & target, cmu::DRIBBLEMODE mode ) {
  //

  if ( mode == cmu::DM_None ) {
    
    Log::debug << "KickToPoint : " <<  target  << endl;
    cmu::Mem->doKickToPoint( target ); 
    getball = false;
    
  } else {
    
   
    Log::debug << "DribbleTo Point: " <<  target  << endl;

    float max_dash_pow = 100;
    cmu::AngleDeg drib_ang = 0;

    cmu::PlayerObject * closestOpponent = cmu::Mem->GetPlayer( cmu::Mem->TheirSide, cmu::Mem->ClosestOpponent() );
    if ( ( closestOpponent != 0 ) &&
	 ( cmu::Mem->MyPos().dist( closestOpponent->get_abs_pos() ) < 3.0 ) ) {

      cmu::Vector dodgePoint = closestOpponent->get_abs_pos();


      if ( cmu::DribbleTo( target, 
			   max_dash_pow, 
			   1.0, 
			   drib_ang, 
			   mode , 
			   cmu::cmu_TRUE, 
			   dodgePoint ) == cmu::DR_LostBall) 
	getball = false;



    } else {

      if ( cmu::DribbleTo( target, max_dash_pow, 1.0, drib_ang, mode ) == cmu::DR_LostBall) 
	getball = false;

    }
    
  }
  
}



bool OffensiveMoveBehaviour::behave() {

//  static int cmudribblecount = 0;

  if (isSituation()) {

    if (!getball) {
      //

      if (!cmu::Mem->BallKickable()) {
	cmu::get_ball();
	return true;
      }
      else
	getball = true;

    }

    if ( holdball == 0 ) {
      //
 
      if ( cmu::Mem->BallKickable() && ballKickableForOpponent() ) {
	holdball = 4;
	cmu::hold_ball();
	return true;
      }
      
    } else
      holdball--;
    
      
    float targetx,targety;
    float goaliex = goalie_x();
    // if (abs(goaliex-cmu::Mem->MyX())>10)
      	
    Log::debug << "goaliex : " << goaliex << endl;
    Log::debug << "Meine Position : " << cmu::Mem->MyPos() << endl;
    targetx = cmu::Mem->MyX() + 0.4 *  (50-cmu::Mem->MyX());
    //targetx = cmu::Mem->MyX() + 0.4 *  (goaliex-cmu::Mem->MyX());
    //targetx = cmu::Mem->MyX() + 5.0;
    
    if (cmu::Mem->MyY()>15)
    {
	if (fabs(goaliex-cmu::Mem->MyX())<=12.0)
	    targety = cmu::Mem->MyY() + 0.4 *  (23-cmu::Mem->MyY());
	else
	    targety = cmu::Mem->MyY() + 0.4 *  (30-cmu::Mem->MyY());
    }
    else if ((cmu::Mem->MyY()>0) && (cmu::Mem->MyY()<=15))
      targety = cmu::Mem->MyY() + 0.4 *  (5-cmu::Mem->MyY());
    else if ((cmu::Mem->MyY()<=0) && (cmu::Mem->MyY()>=-15))
      targety = cmu::Mem->MyY() + 0.4 *  (-5-cmu::Mem->MyY());
    else if (cmu::Mem->MyY()<-15)
    {
	if (fabs(goaliex-cmu::Mem->MyX())<=12.0)
	    targety = cmu::Mem->MyY() + 0.4 *  (-23-cmu::Mem->MyY());
	else
	    targety = cmu::Mem->MyY() + 0.4 *  (-30-cmu::Mem->MyY());
    }
    else
      targety = 0; // nur um die warnung zu beseitigen 

    if (fabs(goaliex-cmu::Mem->MyX())<=12.0)
      {
	
	//if ( cmudribblecount < 3 ) {
	
	dribbleTo( cmu::Vector( targetx, targety) );
	//cmudribblecount++;
	
      } else {
	
	dribbleTo( cmu::Vector( targetx, targety) );
	
      }      
    return true;
    
  }
  


  return false;
    
}

    /*
    float myy = cmu::Mem->MyY();
    float myx = cmu::Mem->MyX();

    cmu::Vector target;
    
    if ( myx > 15 )
      target = cmu::Vector( 52.0, ((myy>0)?16.0:-16.0) );

    else if ( myx > 35 )
      target = cmu::Vector( 52.0, ((myy>0)?9.0:-9.0) );

    else {
      float y = ((myy>0)?myy+9.0:myy-9.0);
      if ( y >  32 ) y = 32;
      if ( y < -32 ) y = -32;
      
      target = cmu::Vector( 52.0, y );
    }
    

    float max_dash_pow = 100;
    cmu::AngleDeg drib_ang = 0;

    cmu::PlayerObject * closestOpponent = cmu::Mem->GetPlayer( cmu::Mem->TheirSide, cmu::Mem->ClosestOpponent() );
    if ( ( closestOpponent != 0 ) &&
	 ( cmu::Mem->MyPos().dist( closestOpponent->get_abs_pos() ) < 3.0 ) ) {

      cmu::Vector dodgePoint = closestOpponent->get_abs_pos();
      if ( cmu::DribbleTo( target, max_dash_pow, 1.0, drib_ang, cmu::DM_Strict, cmu::cmu_TRUE, dodgePoint ) == cmu::DR_LostBall) 
	getball = false;

    } else {

      if ( cmu::DribbleTo( target, max_dash_pow, 1.0, drib_ang, cmu::DM_Lazy ) == cmu::DR_LostBall) 
	getball = false;

    }

    return true;

  } else
    return false;

}
    */


/*
 * $Log: OffensiveMoveBehaviour.cc,v $
 * Revision 1.8  2002/04/13 07:59:17  jens
 * German Open 2002 Edition
 *
 * Revision 1.7  2002/04/11 00:00:41  fastjack
 * Warnungen beseitigt
 *
 * Revision 1.6  2002/04/10 13:24:53  seekamp
 * Dribbling/Schuss verbessert.
 * Steilpaesse werden weniger hart gespielt.
 * Wenn aussen wird Richtung, Eckfahne gedribbelt
 *
 * Revision 1.5  2002/04/09 19:23:14  fastjack
 * Verbesserungen der Dribble und Torschuss Methoden. Bug fixes.
 *
 * Revision 1.4  2002/04/09 12:28:58  seekamp
 * Dribbling Richtung Torwart, wenn ClosestPlayerToTheirGoal
 *
 * Revision 1.3  2002/04/09 00:12:37  fastjack
 * commit
 *
 * Revision 1.2  2002/04/08 13:28:53  fastjack
 * Dribble-Behaviour verbessert
 *
 * Revision 1.1  2002/04/05 16:18:46  fastjack
 * OffensiveMoveBehaviour implemented. Under certain conditions ( which still may/should be improved ) our agent should dribble forward instead of shooting.
 *
 */




