/*****************************************************************************
 * $RCSfile: PotentialField.cc,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: jens $
 * $Date: 2002/04/13 07:59:17 $
 * $Revision: 1.105 $
 *****************************************************************************/

#include "PotentialField.hh"
#include "PFieldLogger.hh"
#include "client.h" 
#include "Log.hh"
#include "world.hh"
#include "gouraud.hh"
#include "BTeamTypes.hh"
#include "CommunicationManager.hh"
#include <stdlib.h>
#include <cmath>

inline int mn(int a,int b) {
  int ergebnis=0;
  if (a<b) ergebnis= a;
  else ergebnis=b;
  return ergebnis;
}

inline int mx(int a,int b) {
  int ergebnis=0;
  if (a>b) ergebnis= a;
  else ergebnis=b;
  return ergebnis;
}

float PotentialField::translateToGlobalX(int x) {
  return  (ORIGINAL_FIELD_SIZE_X*2/(FIELD_SIZE_X))*x-ORIGINAL_FIELD_SIZE_X;
}

float PotentialField::translateToGlobalY(int y) {
  return  (ORIGINAL_FIELD_SIZE_Y*2/(FIELD_SIZE_Y))*y-ORIGINAL_FIELD_SIZE_Y;
}

int PotentialField::translateX(float x)
{
  int ergebnis=0;
  x=x+ORIGINAL_FIELD_SIZE_X;
  ergebnis = (int)(x*((FIELD_SIZE_X)/(ORIGINAL_FIELD_SIZE_X*2)));
  return ergebnis;

}

int PotentialField::translateY(float y)
{
  int ergebnis = 0;
  y=y+ORIGINAL_FIELD_SIZE_Y;
  ergebnis=(int)(y*((FIELD_SIZE_Y)/(ORIGINAL_FIELD_SIZE_Y*2)));
  return ergebnis;

}
// computes the distance between two points
double PotentialField::distance(int x1,int y1,int x2,int y2)	
{
  double ergebnis=0;
  ergebnis = sqrt(((x2-x1)*(x2-x1))+((y2-y1)*(y2-y1)));
  return ergebnis;
}

double PotentialField::double_distance(double x1,double y1,double x2,double y2)
{
  double ergebnis=0;
  ergebnis = sqrt(((x2-x1)*(x2-x1))+((y2-y1)*(y2-y1)));
  return ergebnis;
}

bool PotentialField::isPlayModeCornerKick()
{
  //    return (cmu::Mem->PlayMode == cmu::PM_Their_Corner_Kick) || (cmu::Mem->PlayMode == cmu::PM_My_Corner_Kick);
  //return cmu::Mem->PlayMode == cmu::PM_My_Corner_Kick;
  return false;
}

bool PotentialField::closest_Teammate_to_goal()
{
  return !world->isTeammateCloserToTheirGoal();

/*  for (int i=1;i<world->getNumberOfTeammates();i++)   // dann alle Mitspieler
    {
      if ((world->team[i].isValid()) && (world->team[i].x>world->self.x))
	return false;
    }
  return true; */
}



bool PotentialField::closest_Player_to_goal()
{

  return !world->isPlayerCloserToTheirGoal();

/*  for (int i=1;i<world->getNumberOfTeammates();i++)   // dann alle Mitspieler
    {
      if ((world->team[i].isValid()) && (world->team[i].x>world->self.x))
	return false;
    }

  for(int i=1;i<world->getNumberOfOpponents();i++) // werden die Gegner entsprechend bewertet
    {
        if ((world->opponent[i].isValid()) && (world->opponent[i].x>world->self.x))
	  return false;
    }
  
	
    return true; */
} 


bool PotentialField::lokales_Maximum(int a,int b,int c)
{
  return ((b>a) && (b>c));
}

int PotentialField::pred_horizontal(int x,int y,int xmin)
{
  if (x==xmin)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x-1][y];
}


int PotentialField::succ_horizontal(int x,int y,int xmax)
{
  if (x==xmax)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x+1][y];
}


int PotentialField::pred_vertikal(int x,int y,int ymin)
{
  if (y==ymin)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x][y-1];
}


int PotentialField::succ_vertikal(int x,int y,int ymax)
{
  if (y==ymax)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x][y+1];
}


int PotentialField::pred_diagonal_oben_unten(int x,int y,int xmin,int ymin)
{
  if (x==xmin)
    return fieldInfo[x][y]-1;

  else if (y==ymin)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x-1][y-1];
}


int PotentialField::succ_diagonal_oben_unten(int x,int y,int xmax,int ymax)
{
  if (x==xmax)
    return fieldInfo[x][y]-1;

  else if (y==ymax)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x+1][y+1];
}



int PotentialField::pred_diagonal_unten_oben(int x,int y,int xmin,int ymax)
{
  if (x==xmin)
    return fieldInfo[x][y]-1;

  else if (y==ymax)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x-1][y+1];
}


int PotentialField::succ_diagonal_unten_oben(int x,int y,int xmax,int ymin)
{
  if (x==xmax)
    return fieldInfo[x][y]-1;

  else if (y==ymin)
    return fieldInfo[x][y]-1;
  
  else
    return fieldInfo[x+1][y-1];
}


int PotentialField::ball_orientierung_Zaehler(int min, int max )
{
  int Zaehler=0;
  Zaehler = abs(world->ball.x-min);
  if (Zaehler<0)
    Zaehler=0;
  if (Zaehler>abs(max-min))
    Zaehler=abs(max-min);

  return Zaehler;
}




//////////////////////////////////////////////////////////////////////
// gibt die x-Koordinate des Orientierungspunktes zurueck.	    //
// Der Orientierungspunkt ist der Punkt, zudem der Spieler laufen   //
// wuerde, wenn es keine Mit - und Gegenspieler gaebe.		    //
//////////////////////////////////////////////////////////////////////


  // das Argument dieser Funktion, gibt an in welchem Mannschaftsteil
  // sich der Ball im Moment befindet



int PotentialField::Zeitpunkt_Bewertung()
{
  if (((world->currentTime>2500) && (world->currentTime>2500)) || (world->currentTime>5500))
    return 2;
  else return 1;
}




int PotentialField::Stamina_Bewertung()
{
  if (world->self.stamina>3400)
    return 4;


  else if (world->self.stamina>2500)
    return 3;

  else if (world->self.stamina>1800)
    return 2;

  else
    return 1;


}




int PotentialField::Zielpunkt_Bewertung(int x,int y)
{
  if ((((world->ball.x>Abseitslinie) && (x<Abseitslinie)) | (x<(world->ball.x-(int)(0.05*FIELD_SIZE_X)))) && (!world->teamBallPossession))
    return 8;

  float dist = double_distance(translateToGlobalX(x),translateToGlobalY(y),translateToGlobalX(world->self.x),translateToGlobalY(world->self.y));
  if (dist>10.0)
    return 3;
  else if (dist>3.0)
    return 2;
  else if (dist>1.0)
    return 1;
  else
    return -3;
    
}




int PotentialField::Aktions_Bewertung()
{
  int bewertung = 0;


  if (world->isMyOffsidePosition(world->self.x))
    bewertung = bewertung + 2;
  
  float dist = double_distance(translateToGlobalX(world->ball.x),translateToGlobalY(world->ball.y),translateToGlobalX(world->self.x),translateToGlobalY(world->self.y));
  if (dist>27.0)
    bewertung=bewertung+1;


  else if (dist>15.0)
    bewertung=bewertung+2;

  else if (dist>7.0)
    bewertung=bewertung+3;

  else
    bewertung=bewertung+4;


  if ((my_Mannschaftsteil==3) && (world->teamBallPossession))
    bewertung=bewertung+1;

  if ((my_Mannschaftsteil==1) && (!world->teamBallPossession))
    bewertung=bewertung+1;


  if ((my_Mannschaftsteil==0) && (world->ball.x<(int)(0.3*FIELD_SIZE_X)))
      return true;      

  return bewertung;

}


bool PotentialField::manndeckerAktionsAusfuehrung()
{
  if ((my_Mannschaftsteil==1) && (manndeckung) && (world->ball.x<(int)(0.25*FIELD_SIZE_X)) && (!world->teamBallPossession))
    return true;
  else return false;
}









bool PotentialField::Aktions_Ausfuehrung(int x,int y)
{
  int Schwellwert = 8;
  int action = Zeitpunkt_Bewertung() + Stamina_Bewertung() + Zielpunkt_Bewertung(x,y) + Aktions_Bewertung();
  // Log::info << "Aktions_Ausfuehrung" << action << endl;
  
  if (manndeckerAktionsAusfuehrung())
    return true;
  
  return action>Schwellwert;
}

Point PotentialField::Torwart_Ball_Schnittpunkt()
{
  // Log::debug << "Torwart-Ball-Schnittpunkt" << endl;
  int x,y;
  x= (int)(world->ball.x/5);

  if ((world->ball.y>0.25*FIELD_SIZE_Y) && (world->ball.y<0.75*FIELD_SIZE_Y) && world->ball.x<(int)(0.3*FIELD_SIZE_X))
      //    y = world->ball.y;
      y= (int)(FIELD_SIZE_Y/2+(world->ball.y-FIELD_SIZE_Y/2)/2);

  else
     y= (int)(FIELD_SIZE_Y/2+(world->ball.y-FIELD_SIZE_Y/2)/5);


  Point Schnitt;
  Schnitt.x=x;
  Schnitt.y=y;

  Log::debug << "Torwart-Ball Schnittpunkt" << Schnitt.x << "," << Schnitt.y << endl;
  return Schnitt;
}


void PotentialField::drawLine(cmu::Vector start,cmu::Vector end)
{
  int lineValue = 10000;
  double delta_y = (end.y-start.y)/(end.x-start.x);
  
  for (int i=(int)(start.x);i<(int)(end.x);i++)
    {
      fieldInfo[i][(int)(start.y+delta_y*i)]=lineValue;
    }
}


void PotentialField::fillCircle(cmu::Vector center,double radius)
{
  int circleValue = -10000;
  int y;
  int mittel_x = (int)center.x;
  int mittel_y = (int)center.y;
  
  for (int x=0; x<(int)radius;x++)
    {
      y =(int)(sqrt(radius*radius-x*x));
      fieldInfo[mittel_x+x][mittel_y+y]=fieldInfo[mittel_x+x][mittel_y+y]+circleValue;
      fieldInfo[mittel_x+x][mittel_y-y]=fieldInfo[mittel_x+x][mittel_y-y]+circleValue;
      fieldInfo[mittel_x-x][mittel_y+y]=fieldInfo[mittel_x-x][mittel_y+y]+circleValue;
      fieldInfo[mittel_x-x][mittel_y-y]=fieldInfo[mittel_x-x][mittel_y-y]+circleValue;
    }
}





int PotentialField::ball_orientierung(int Mannschaftsteil)
{
  int Zaehler=0;
  int Nenner=0;
  int min = 0;
  int Spanne = 0;
  int ergebnis = 0;

  // je nach my_Mannschaftsteil ( gibt an ob wir Abwehrspieler (1), Mittelfeldspieler(2),
  // Stuermer(3) sind) gibt es eine bestimmte Spanne  in der wir uns
  // in x-Richtung bewegen. (Abwehrspieler  ruecken z.B. hoechstens bis
  // zur Mittellinie auf, Stuermer haben im eigenem Strafraum nicht zu suchen)




  if (my_Mannschaftsteil==1)
    {
      min = min_Abwehr_x;
      Spanne = max_Abwehr_x-min_Abwehr_x;
    }		

  if (my_Mannschaftsteil==2)
    {
      min = min_Mittelfeld_x;
      Spanne = (max_Mittelfeld_x-int(0.25*FIELD_SIZE_X))-min_Mittelfeld_x;
    }

  if (my_Mannschaftsteil==3)
    {
      min = min_Sturm_x;
      Spanne = max_Sturm_x-min_Sturm_x;
    }


  // der Orientierungspunkt verschiebt sich in Abhaengigkeit zur Ballposition.
  // Allerdings ist dabei zu beachten, welche Mannschaft den Ball hat und in
  // welchem Mannschaftsteil sich der Ball befindet. ( hat ein Abwehrspieler
  // an der Mittellinie den Ball, ist dies ander zu bewerten, als wenn ein
  // Stuermer an der Mittellinie den Ball hat.


  if (Mannschaftsteil==1)
    {
      if (world->teamBallPossession)
	Zaehler = ball_orientierung_Zaehler(min_Abwehr_x,max_Abwehr_x);
      else
	Zaehler = ball_orientierung_Zaehler(FIELD_SIZE_X-max_Abwehr_x,FIELD_SIZE_X-min_Abwehr_x);

      Nenner = abs(max_Abwehr_x-min_Abwehr_x);
    }		
  if (Mannschaftsteil==2)
    {
      if (world->teamBallPossession)
	Zaehler = ball_orientierung_Zaehler(min_Mittelfeld_x,max_Mittelfeld_x);
      else
	Zaehler = ball_orientierung_Zaehler(FIELD_SIZE_X-max_Mittelfeld_x,FIELD_SIZE_X-min_Mittelfeld_x);

      Nenner = abs(max_Mittelfeld_x-min_Mittelfeld_x);
    }

  if (Mannschaftsteil==3)
    {
      if (world->teamBallPossession)
	Zaehler = ball_orientierung_Zaehler(min_Sturm_x,max_Sturm_x);
      else
	Zaehler = ball_orientierung_Zaehler(FIELD_SIZE_X-max_Sturm_x,FIELD_SIZE_X-min_Sturm_x);

      Nenner = abs(max_Sturm_x-min_Sturm_x);
    }

  // das Ergebnis liefert den x-Wert des Orientierungspunktes zurueck
  // das Verhaeltnis Zaehler/Nenner gibt an, wo sich der Ball innerhalb
  // des entsprechenden Mannschaftsteils, in Abhaenhigkeit von dessen Spanne,
  // befindet.
  // Beispiel: Ball ist in der eigenen Abwehr. Die x-Position ist 12. Der Abwehrbereich
  //	       umfasst den Bereich von x=0 bis x=20. Dann ist der Zaehler 12 und der
  //	       Nenner 20.


  ergebnis = min + (int)(Spanne*((double)Zaehler/(double)Nenner));
  // durch diese Formel stellen wir sicher, dass der x-Wert des Orientierunsgspunktes
  // (ergebnis) sich in Relation zum Mannschaftsteil des Spielers genauso verhaelt, wie
  // der Ball zum Mannschaftsteil in dem er sich befindet.


  if (((world->playMode==cmu::PM_My_Free_Kick) ||  (world->playMode==cmu::PM_My_Offside_Kick)) &&  (world->ball.x<0.5*FIELD_SIZE_X))
    {
      if (ergebnis<world->ball.x)
	return world->ball.x+(int)(0.1*FIELD_SIZE_X);
    }
  


  if ((world->playMode==cmu::PM_My_Goal_Kick) ||
				 (world->playMode==cmu::PM_My_Goalie_Free_Kick))
    
    {
      if (ergebnis <(int)(0.3*FIELD_SIZE_X))
	{
	  Log::debug << "Abschlag oder Abstoss 2" << endl;
	  return (int)(0.3*FIELD_SIZE_X);
	}
    }
  
  
  if ((my_Mannschaftsteil == 1) && (world->teamBallPossession) && (world->ball.x<Abseitslinie))
    {
      if (ergebnis<world->ball.x)
	return world->ball.x;
    }
 
  
  return ergebnis;
}


// diese Methode berechnet die Bewertung jedes einzelnen Feldes fuer den Fall,
// dass der Spieler nicht im Ballbesitz ist. Gegenspieler und Mitspieler werden in
// dieser Methode nicht beruecksichtigt, sondern in erster Linie die Entfernug zum
// Orientierungspunkt.


int PotentialField::Abseitsfalle(int x)
{
   if (world->ball.x>Abseitslinie)
    return Abseits_Wert;
  
   else
    {
      if (x<(world->ball.x-(int)(0.05*FIELD_SIZE_X)))
	return Abseits_Wert;
      
      return 0;
    }
}

int PotentialField::offsideLineX()
{
  int ergebnis=0;
  if (world->ball.x>Abseitslinie)
    ergebnis = Abseitslinie;

  else
    ergebnis = (world->ball.x-(int)(0.05*FIELD_SIZE_X));

  
  if (ergebnis <(int)(0.12*FIELD_SIZE_X))
    ergebnis=(int)(0.12*FIELD_SIZE_X);

  return ergebnis;
  

}


int PotentialField::no_ball_posession(int x,int y,int Orientierungsx)
{
  int Evaluation = 0;
  int Orientierungsy = 0;
   //Orientierungsy = (world->ball.y * ( abs(world->ball.y-selfGrund_y) / FIELD_SIZE_Y / 2 )) + selfGrund_y;

 
  Orientierungsy = selfGrund_y + ((world->ball.y-FIELD_SIZE_Y/2)/5);
  // wenn linker Aussenverteidiger und der Gegner greift ueber die rechte Seite an, soll ich mich in die 
  // Mitte orientieren
  
  if ((selfGrund_y<15) && (world->ball.y > 45) && (world->ball.x<30))
    Orientierungsy=25;
  // analog fuer den rechten Aussenverteidiger
  if ((selfGrund_y>45) && (world->ball.y <15) && (world->ball.x<30))
    Orientierungsy=35;
  

  if (Orientierungsy<0)
    Orientierungsy=0;

  if (Orientierungsy>FIELD_SIZE_Y)
    Orientierungsy=FIELD_SIZE_Y;
  
  if (my_Mannschaftsteil == 1)
    {
      if (world->ball.x>=Abseitslinie)
	{
	 
	  if ((x-Orientierungsx)>1) 
	    {
	      Evaluation = Evaluation - 100000;
	    }
	} 
      
      else {
	
	if (world->ball.x>=(int)(0.3*FIELD_SIZE_X))
	  {
	    if ((x-Orientierungsx)>4) 
	      {
		Evaluation = Evaluation - 100000;
	      }	
	  } 
	else {
	    
	  if ((x-Orientierungsx)>8) 
	    {
	      Evaluation = Evaluation - 100000;
	    }	
	}
      }
     
      
      if ((cmu::Mem->MyNumber == 6) && (abs(y-Orientierungsy)>9))
	 Evaluation = Evaluation - 100000;
      
      if (((cmu::Mem->MyNumber == 4) || (cmu::Mem->MyNumber == 5))  && (abs(y-Orientierungsy)>6))
	 Evaluation = Evaluation - 100000;
      
      if (((cmu::Mem->MyNumber == 2) || (cmu::Mem->MyNumber == 3))  && (abs(y-Orientierungsy)>8))
	 Evaluation = Evaluation - 100000; 

      
    }

 
  if ((world->ball.x>=Abseitslinie) && (!world->teamBallPossession))
  {
      if ((my_Mannschaftsteil==2) && (abs(x-(Abseitslinie+10)>3))) 
      {
	  Evaluation = Evaluation - 100000;
      }
      if ((my_Mannschaftsteil==3) && (abs(x-(Abseitslinie+20)>3)) && (!world->isMyOffsidePosition(x))) 
      {
	  Evaluation = Evaluation - 100000;
      }
  }
  
  
  if (my_Mannschaftsteil>1)
  {
      if (abs(y-Orientierungsy) > 8)
	  Evaluation = Evaluation - 100000;
  }
  // der x-Wert des Orientierungspunktes wurde bereits oben in einer eigenen Methode
  // berechnet. Der y-Wert berechnet sich ausschliesslich in Abhaengigkeit zur Grund-
  // y-Position (selfGrund_y) (statisch) und zur y-Position des Balles ( dynamisch).
  
  if (isPlayModeCornerKick())
    {
      // Log::debug << "Ecken " << selfEcken_x << endl;
      
      Orientierungsx = (selfEcken_x + world->ball.x)/Positionsbewertung;
      Orientierungsy = (selfEcken_y + world->ball.y)/Positionsbewertung+Taktik/10;
    }


  // Evaluation gibt die Bewertung eines Rasterfeldes an.
  // Dies geschieht indem wir die Entfernung eines jeden Feldes vom Orientierungspunkt
  // berechnen, diesen Wert von der Positionsbewertung abziehen und dann mit der
  // Positionsprioritaet multiplizieren. Der Effekt ist, dass Felder die weit vom
  // Orientierungspunkt entfernt sind, schlechter bewertet werden.
  // Somit haelt der Spieler immer ungefaehr seine Grundposition in Abhaengigkeit
  // zur aktuellen Spielsituation.

  Evaluation = Evaluation + (int)(Positionsbewertung - abs((int)distance(Orientierungsx,Orientierungsy,x,y))*Positionsprioritaet);


  // if (((!world->teamBallPossession) | (world->ball.x>(int)(0.6*FIELD_SIZE_X))) && (my_Mannschaftsteil>0) && (x<Abseitslinie))
    if ((my_Mannschaftsteil>0) && (x<Abseitslinie))
      Evaluation = Evaluation + Abseitsfalle(x);


  if ((my_Mannschaftsteil>1) && world->isMyOffsidePosition(x))
    {
      Evaluation=Evaluation + Anti_Abseitsfallen_Wert;
    }

  return Evaluation;

}


// Diese Methode bewertet jedes einzelne Rasterfeld, fuer den Fall,dass der Spieler
// den Ball hat. Hier wird erstmal jedes einzelne Feld in Bezug auf seine relative
// Position zum Spieler bewertet. Auf Mitspieler und Gegenspieler wird in dieser
// Methode keine Ruecksicht genommen.



int PotentialField::ball_posession(int x, int y)
{
  int Evaluation=0;
  int Berechnungs_x=0;

 

  // Wir wollen Tore schiessen, das gegnerische Tor steht vorne, also soll der Ball nach vorne
  // gespielt werden. Dementsprechend, werden alle Felder die hinter dem Ball, und
  // somit hinter dem Spieler liegen, negativ bewertet. Je naeher der Punkt zum eigenem
  // Tor liegt, desto schlechter wird er bewertet.

  if ((my_Mannschaftsteil==0) && ((world->playMode==cmu::PM_My_Goal_Kick) ||
				 (world->playMode==cmu::PM_My_Goalie_Free_Kick)))
    {
       if  ((x-world->ball.x)<35)
	{
	  //  Evaluation= Evaluation - 200000;
	}



      // wenn der Torwart rechts steht soll er auch nach rechts abstossen
      if (world->ball.y>FIELD_SIZE_Y/2)
	{
	
	  if (y>world->ball.y)
	    {
	      // Evaluation=Evaluation+100000;
	    }
	}

      else {
	
	  if (y<=world->ball.y){
	    //Evaluation=Evaluation+100000;
	  }
	}

    }





  if ((world->ballpossessing) && (world->ball.x<(int)(0.25*FIELD_SIZE_X)))
  {
    // if(x<(int)(0.25*FIELD_SIZE_X))
    //  {
    //	Evaluation=Evaluation-5000;
    //  }

    if (world->ball.y>FIELD_SIZE_Y/2)
      {
	
	if (y>world->ball.y)
	    {
	      Evaluation=Evaluation+300;
	    }
      }

    else {

	if (y<=world->ball.y){
	  Evaluation=Evaluation+300;
	}
    }
  }
  int ball_x = world->ball.x;
  int ball_y = world->ball.y;
  

  // fuer den Fall eines Einwurfs soll der Ball nicht direkt an der Linie entlang gespielt, deswegen wird hier die Bewertung
  // etwas nach innen verlagert, weil der Ball sonst direkt ins Aus geschossen wird.

  if (world->playMode==cmu::PM_My_Kick_In)
    {
      if (world->ball.y<(int)(0.07*FIELD_SIZE_Y))
	ball_y = (int)(0.07*FIELD_SIZE_X);
      

      if (world->ball.y>(int)(0.93*FIELD_SIZE_Y))
	ball_y = (int)(0.93*FIELD_SIZE_X);
    }
  

  if (x<ball_x)
    {
      if(distance(ball_x,ball_y,x,y)<Entfernungswert)
	{
	  Evaluation = Evaluation + 10*(x-world->ball.x) * Rueckpassprioritaet;
	
	}
      // danach nimmt die Bewertung ab. Dadurch soll das optimale Verhaeltnis zwischen
      // Raumgewinn und Risiko bei Paessen abgebildet werden.
      else
	{
	 Evaluation = Evaluation + int(10*(-distance(ball_x,ball_y,x,y)) * Rueckpassprioritaet);
	}
    }
  
  // fuer den Fall,dass das zu bewertende Rasterfeld vor uns liegt, untersuchen wir
  // ebenfalls die Entfernung zum Ball. Bis zu einer gewissen Entfernung (Entfernungswert)
  // steigt die Bewertung ...
  else
    {
      if(distance(ball_x,ball_y,x,y)<Entfernungswert)
	{
	  Evaluation = Evaluation + 2*(x-world->ball.x) * Entfernungsprioritaet;
	
	}
      // danach nimmt die Bewertung ab. Dadurch soll das optimale Verhaeltnis zwischen
      // Raumgewinn und Risiko bei Paessen abgebildet werden.
      else
	{
	  if ((x-ball_x)>=Entfernungswert)
	    Berechnungs_x=Entfernungswert;
	  else
	    Berechnungs_x=(x-ball_x);
	  Evaluation= Evaluation + (int)(Berechnungs_x - (distance(ball_x,ball_y,x,y)-Entfernungswert))*10* Entfernungsprioritaet;
	}

    }




  // die Felder vorm gegnerischen Tor werden in Abhaengigkeit zur Entfernung zum Ball
  // bewertet. Je naeher der ballfueherende Spieler am gegnerischen Tor ist, desto
  // hoeher wird der Bereich im gegnerischen Tor bewertet und somit steigt die
  // Wahrscheinlichkeit fuer einen Torschuss.

  if ((y>=linkerPfosten_y) && (y<=rechterPfosten_y) && (x==FIELD_SIZE_X-2) && world->ballpossessing && (world->self.x>=(int)(0.75*FIELD_SIZE_X)))
    {
      Evaluation= Evaluation + (int)(Torschussbewertung-distance(world->ball.x,world->ball.y,x,y))*Torschussprioritaet;
      if (y==linkerPfosten_y)
	Evaluation = Evaluation + 10000;

      if (y==rechterPfosten_y)
	Evaluation = Evaluation + 10000;
    }

  if ((closest_Teammate_to_goal()) && (world->self.x>=(int)(0.75*FIELD_SIZE_X)) && (world->ballpossessing))
    {
      if ((y>=linkerPfosten_y) && (y<=rechterPfosten_y) && (x==FIELD_SIZE_X-2) && world->ballpossessing)
	{
	

	  // Log::info << "Torschuss" << endl;
	  // Evaluation= Evaluation + (int)(100000-distance(world->ball.x,world->ball.y,x,y))*Torschussprioritaet;
	  // Log::info << "linker Pfosten" << linkerPfosten_y << endl;
	
	

	  //	  if (y==linkerPfosten_y)
	    //Evaluation = Evaluation + 10000;
	
	    //if (y==rechterPfosten_y)
	    //Evaluation = Evaluation + 10000;
	}
    }


  if ((closest_Teammate_to_goal()) && (x-world->self.x==2) && (world->self.x<(int)(0.75*FIELD_SIZE_X)) && (world->ballpossessing))
    {
      // if (((world->self.y)>FIELD_SIZE_Y/2) && (y==(int)world->self.y-(world->self.y-FIELD_SIZE_Y/2)/8))
	//Evaluation = Evaluation + 100000;


      //if (((world->self.y)<=FIELD_SIZE_Y/2) && (y==(int)world->self.y+(FIELD_SIZE_Y/2-world->self.y)/8))
	//	Evaluation = Evaluation + 100000;
      // Log::info << "Frei vorm Tor" << endl;
    }


  // Ist ein Rasterfeld nah am Spieler, also im sogenannten Dribbelbereich, wird dieser
  // Bereich in Bezug aufs Dribbeln bewertet. Je mehr Kraft (Stamina) der Spieler hat,
  // desto hoeher ist seine Dribbelbereitschaft.
  // Das der Spieler nach vorne und nicht nach hinten dribbelt, wurde bereits durch die
  // obigen Bewertungen in dieser Methode sichergestellt.


  if (((distance(world->ball.x,world->ball.y,x,y)) < Dribbelbereich) && (world->ballpossessing) && !(world->isMyStandardSituation()))
    {
      Evaluation = Evaluation + 0;

      // Evaluation=(-50+world->self.stamina)*Staminaprioritaet;
    }


  /*  if (x>=88)
    Log::debug << "Bereich im gegn. STrafraum" << Evaluation << endl;
  */
  return Evaluation;
}


int PotentialField::Anzahl_Spieler_in_Rechteck(int x,int y,int x2,int y2,bool Gegner)
{
  int Anzahl = 0;
    
  if (Gegner)
    {
      
      for(int i=0;i<world->getNumberOfOpponents();i++) // werden die Gegner entsprechend bewertet
	{
	  if (world->opponent[i].isValid())
	    {
	      if ((world->opponent[i].x>=x) && (world->opponent[i].y>=y) &(world->opponent[i].x<=x2) &(world->opponent[i].y<=y2))
		Anzahl++;
	      
	    }
	}
    } 

  else 
    {
      
      for(int i=1;i<world->getNumberOfTeammates();i++)	   // und die Mitspieler
	{
	  if (world->team[i].isValid())
	    {
	      if ((world->team[i].x>=x) && (world->team[i].y>=y) && (world->team[i].x<=x2) && (world->team[i].y<=y2))
		Anzahl++;
	    }
	}
    }
  
  return Anzahl;
  

}


int PotentialField::y_Bewertung_goalie(bool links)
{
  int bewertung[FIELD_SIZE_Y];
  for (int k=0;k<FIELD_SIZE_Y;k++)
    {
      bewertung[k]=0;
    }
  

  int i;
  for(i=0;i<world->getNumberOfOpponents();i++) // werden die Gegner entsprechend bewertet
    {
      if ((world->opponent[i].isValid()) && (world->opponent[i].x < 0.35*FIELD_SIZE_X))
	{
	  Log::debug << "Gegnspieler an der Position " << world->opponent[i].x << "," << world->opponent[i].y << endl;
	  
	  for (int j=0;j<8;j++)
	    {
	      if ((world->opponent[i].y -j)>0)
		bewertung[world->opponent[i].y-j]=bewertung[world->opponent[i].y-j]+(7-j);
	      
	      if (((world->opponent[i].y+j)<FIELD_SIZE_Y) && (j>0)) 
		bewertung[world->opponent[i].y+j]=bewertung[world->opponent[i].y+j]+(7-j);
	    }
	}
      
    }
  
  int min = 0;
  int minwert = 100;
  
  int min_links =(int)(0.25*FIELD_SIZE_Y);
  int max_links =(int)(0.5*FIELD_SIZE_Y);
  int min_rechts = (int)(0.5*FIELD_SIZE_Y);
  int max_rechts = (int)(0.75*FIELD_SIZE_Y);
  if (links)
    {
      for (i=max_links;i>min_links;i--)
	{
	  Log::debug << "Torwart links " << i << " " <<  bewertung[i] << endl;
	  if (bewertung[i]<minwert)
	    {
	      minwert = bewertung[i];
	      min = i;
	    }
	}
    } 
  else
    { 
      for (i=min_rechts;i<max_rechts;i++)
	{ 
	  Log::debug << "Torwart rechts" << i << " " << bewertung[i] << endl;
	  if (bewertung[i]<minwert)
	    { 
	      minwert = bewertung[i];
	      min = i;
	    }
	}
    } 
  Log::debug << "Der y-Wert zu dem ich gehen will ist : " << min << endl;
  

  return min;
}



int PotentialField::move_goalie()
{
  int Ergebnis=0;
  float linkerQuotient = 0;
  float rechterQuotient = 0;
  int anzahl_Mitspieler = 0;
  int anzahl_Gegner = 0;
  

  anzahl_Mitspieler = Anzahl_Spieler_in_Rechteck(world->self.x,0,(int)(0.5*FIELD_SIZE_X),(int)(0.5*FIELD_SIZE_Y),false);
  anzahl_Gegner = Anzahl_Spieler_in_Rechteck(world->self.x,0,(int)(0.5*FIELD_SIZE_X),(int)(0.5*FIELD_SIZE_Y),true);

  //  Log::debug << "Anzahl Mitspieler links" << anzahl_Mitspieler << endl;
  //  Log::debug << "Anzahl Gegner links" << anzahl_Gegner << endl;
  
  if (anzahl_Gegner==0)
    anzahl_Gegner = 1;
  
  linkerQuotient = anzahl_Mitspieler/anzahl_Gegner;
  
  anzahl_Mitspieler = 0;
  anzahl_Gegner = 0;
  
  anzahl_Mitspieler = Anzahl_Spieler_in_Rechteck(world->self.x,(int)0.5*FIELD_SIZE_Y,(int)(0.5*FIELD_SIZE_X),FIELD_SIZE_Y,false);
  anzahl_Gegner = Anzahl_Spieler_in_Rechteck(world->self.x,(int)0.5*FIELD_SIZE_Y,(int)(0.5*FIELD_SIZE_X),FIELD_SIZE_Y,true);
 
  if (anzahl_Gegner==0)
    anzahl_Gegner = 1;
  
  //  Log::debug << "Anzahl Mitspieler rechts " << anzahl_Mitspieler << endl;
  //  Log::debug << "Anzahl Gegner rechts " << anzahl_Gegner << endl;
 
  rechterQuotient = anzahl_Mitspieler/anzahl_Gegner;
  
  if (linkerQuotient>rechterQuotient)
    {
      Ergebnis = y_Bewertung_goalie(true);
      
    } else {
      Ergebnis = y_Bewertung_goalie(false);
    }
  
  return Ergebnis;
}













// Diese Methode gibt die Aktion zurueck, die aufgrund des aktuellen Potentialfelds
// ausgefuehrt werden soll.
// Die Aktion wird in Form eines Zeigers auf ein Int-Array zurueckgegeben. Uebergeben
// wird der beste Punkt.


int* PotentialField::getAction(int x,int y)
{
  //    int* Aktion;

  Aktion[0]=x;	 // Der x-Wert des besten Punktes
  Aktion[1]=y;	 // Der y-Wert des besten Punktes

  Log::debug << "action.x " << Aktion[0] << endl;
  

  if ((x==-1) && (y==-1))
    {
      y = move_goalie();
      Aktion[0]=(int)(FIELD_SIZE_X/7);
      Aktion[1]=y;
      Aktion[2]=4;
      // Log::info << "Action wir returnt" << endl;
      return Aktion;

    }

  if ((x==world->ball.x) && (y==world->ball.y))
    {
      Aktion[2]=3;
      // Log::info << "get_ball" << endl;
      return Aktion;

    }

  else{

    if (world->ballpossessing==false)
      {
	// Log::info << "Laufen" << endl;
	if (Aktions_Ausfuehrung(x,y))
	  Aktion[2]=0;	 // wenn der Spieler nicht den Ball hat soll er laufen = 0
	
	else
	  return NULL;
      }


    else
      {
	if ((abs(x-world->ball.x) < Dribbelbereich) && (abs(y-world->ball.y) < Dribbelbereich))
	  {
	    // Log::debug << "Dribbeln von " << world->self.x << "," << world->self.y << " nach" << x << "," << y << endl;
	     
	    Aktion[2]=2;	// Wenn der Spieler den Ball hat und der beste Punkt in seinem
	    // Dribbelbereich liegt soll er dribbeln = 2
	  }
	else
	  { // Log::info << "Passen zu Punkt" << x << "," << y << endl;
	
	    Aktion[2]=1;    // sonst soll er passen = 1
	  }


      }
    if (Aktion[2]==1)	  // wenn der Spieler passen soll, wird die Haerte des Passes
      { 
	if (world->ball.x<(int)(0.3*FIELD_SIZE_X))         // vom Zielpunkt vorgegeben.
	{
	  Aktion[3]=1;
	}
	else
	  Aktion[3]=0;
	

      }
  }
  if (Aktion[2]==2)	
    Aktion[3]=100-(int)distance(45,15,world->self.x,world->self.y);

  //  if(Aktion[2]==0)	 // die Schnelligkeit des Laufens ist abhaengig von der Ballentfernung
    // von der Orientierungspunktentfernung und von der Stamina.



  return Aktion;
}


// diese Methode fuellt den cone hinter einem Gegenspieler mit Werten. Die Werte
// sind so hoch, dass dieser Bereich fuer einen Pass nicht in Frage kommt.



void PotentialField::set_cone_Bewertung(int x, int y)
{

  int max = -10000;

  // es muss zudem jeweils ueberprueft werden ob der uebergebene Wert die Begrenzungen
  // des Feldes nicht ueberschreitet.


  if ((x>=x_min) && (x<=x_max) && (y>=y_min) && (y<=y_max))
    {
      fieldInfo[x][y]=max;
    }
}


// die
// diese Methode setzt hinter jeden Gegenspieler einen trapezfoermigen Bereich. Dieser
// Bereich soll nicht angespielt werden, da der Ball dann vom Gegner abgefangen werden wuerde

int PotentialField::geraden_Schnittpunkt(double m,double a,double n, double b)
{
  if ((m-n)==0)
    return 0;
  
  return (int)((b-a)/(m-n));
}




void PotentialField::set_cone(int ballx,int bally, const BasicObject &opp)
{
  // opp_radius_x = ball_in_zyklen(opp) Wie weit kann der Spieler laufen bis der Ball bei ihm ist
  // cone_end_width = ball_in_zyklen(opp+length)
  // opp_radius_y = fester_Wert + Balldistanz/x
  //  Log::debug << "set cone..." << endl;
  
  int opp_radius_x=7;
  int opp_radius_y=5;
  int x_Distanz = opp.x - ballx;
  int y_Distanz = opp.y - bally;
  double hypothenuse = sqrt(x_Distanz*x_Distanz + y_Distanz*y_Distanz);
  
  double m;
  if ((y_Distanz==0) && (x_Distanz>0))
    m=100;
  
  else if ((y_Distanz==0) && (x_Distanz<=0))
    m=-100;
  
  else
    m =-x_Distanz/(double)y_Distanz;
  


  double a;
  if (opp.x>0)
    a = opp.y + (-opp.x*m);
  
  else 
    a = opp.y + (opp.x+2)*m;
  
  
  int x_Distanz2= opp.x;
  if (opp.x==0)
    x_Distanz2=2;
  
  int y_Distanz2 = (int)(opp.y-a);
  double hypothenuse2 = sqrt(x_Distanz2*x_Distanz2 + y_Distanz2*y_Distanz2);
  
  int gerade1_y = (int)(opp.y + (y_Distanz2 * opp_radius_x/hypothenuse2));
  int gerade1_x = (int)(opp.x + (x_Distanz2 * opp_radius_x/hypothenuse2));
  //int gerade2_x = (int)(opp.x - (x_Distanz2 * opp_radius_x/hypothenuse2));
  if (gerade1_x==ballx)
    gerade1_x=gerade1_x+1;
  
  
  double n = (gerade1_y-bally)/(double)(gerade1_x-ballx);
  double b = bally + (-ballx*n);
  if (hypothenuse==0)
    hypothenuse=0.1;
  
  
  bool to_close=false;
  double quotient = opp_radius_y/hypothenuse;
  
  if (quotient > 1.0){
    quotient = 0.95;
    to_close = true;
  }
  
  
  int calculatedOppY = opp.y - (int)(y_Distanz * quotient);
  int calculatedOppX = opp.x - (int)(x_Distanz * quotient);
  
  a = calculatedOppY + (-calculatedOppX*m);
  
  int x1 = geraden_Schnittpunkt( m, a, n, b);
  int y1 = (int)(n*x1+b);

  int widthNear = int(distance(calculatedOppX,calculatedOppY,x1,y1))*2; 
  if ((widthNear<4) | (to_close))
    widthNear=4;
  int widthFar =  widthNear*2; 
  // int widthNear = 15; 
  // int widthFar =  20; 
  int length = 30;     // Laenge des Cones nach hinten 
  cmu::Vector vec1(calculatedOppX,calculatedOppY);  
  cmu::Vector vec2(ballx,bally);  
  float orientation = (float)(vec1-vec2).dir(); // Rotationswinkel in Grad.
  int h1,h2,h3,h4;  

  h1 = h2 = -8000; //
  h3 = h4 = -8000; //

  Log::debug << "shade trapez... " << (orientation+180) << "Grad ; for opponent " << opp.unum << endl;
  filler->shadeTrapezoid(calculatedOppY,calculatedOppX,  
			 widthNear,widthFar,   
			 length,orientation+180,   
			 h1,h2,h3,h4);
  Log::debug << "trapez done" << endl;
  //  Log::debug << "...done set cone." << endl;

}
  


// berechnet den Laufweg eines Spielers. Auf der Basis des letzten Punktes und
// des aktuellen Punktes, wird der wahrscheinliche naechste Punkt berechnet.
// Dies geschieht durch einfache Verlaengerung des Vektors zwischen altem und
// aktuellem Punkt


Point PotentialField::getAusrichtung(const BasicObject &opp)
{
  int deltax = opp.x - opp.altesx;
  int deltay = opp.y - opp.altesy;
  Point p;
  p.x = opp.x+(deltax/Ausrichtung);
  p.y = opp.y+(deltay/Ausrichtung) ;

  if(p.x>FIELD_SIZE_X)p.x=FIELD_SIZE_X-1;
  if(p.x<0)p.x=0;
  if(p.y>FIELD_SIZE_Y)p.y=FIELD_SIZE_Y-1;
  if(p.y<0)p.y=0;


  return p;
}





// diese Methode setzt einen Wert in ein Rasterfeld, dass durch einen Spieler
// verursacht wurde. Wenn der Spieler in Ballbesitz ist, er also einen Pass
// spielen soll, duerfen Felder nicht von mehreren Mitspielern bewertet werden.
// Deswegen wird hier mit Hilfe des Hilfsarrays Mitspieler_bew jeweils ueberprueft
// ob ein Feld schon von einem Mitspieler bewertet wurde, wenn ja wird die hoehere
// Bewertung gewaehlt.
// Hintergedanke: ein Mitspieler der voellig frei in guter Position steht, soll
// besser bewertet werden als ein Bereich in dem wir ein Mitspieler-Gegner-Verhaeltnis
// von 4:2 haben.




void PotentialField::set_Player_value(int x,int y, int eval, bool Gegner)
{

  if ((Mitspieler_bew[x][y] > 0) && (Gegner==false) && (world->ballpossessing==true))
    {
      if (Mitspieler_bew[x][y]>eval)
	{
	  eval=0;
	}
      else
	{
	  eval=eval-Mitspieler_bew[x][y];
	}
    }	


  fieldInfo[x][y] = fieldInfo[x][y]+eval;

  if (world->ballpossessing)
  if ((Gegner==false) && (world->ballpossessing==true))
    {
      Mitspieler_bew[x][y] = Mitspieler_bew[x][y] + eval;
    }
}


// diese Methode setzt die Suboptimalitaet um. Es wird fuer jeden Mitspieler geschaut
// ob in einem Bereich vor ihm ein Mitspieler steht (Steilpass), wenn ja wird geprueft
// ob dieser frei steht und anspielbar ist, wenn ja bekommt dieser Mitspieler einen
// Bonus, weil er, wenn er angespielt wird, die Moeglichkeit hat den Ball gut weiterzuspielen.


int PotentialField::get_Suboptimalitaet_Bonus(const BasicObject &player)
{
  // Log::debug << "Suboptimalitaet" << endl;


  BasicObject best_player;
  best_player.x=0;
  best_player.y=0;
  best_player.altesx=0;
  best_player.altesy=0;

  // welcher Spieler steht innerhalb eines Bereichs vor dem Mitspieler am guenstigsten ?

  for (int i=0;i<world->getNumberOfTeammates();i++)
    {
      if ((world->team[i].x>player.x) && (world->team[i].x<=player.x+cone_laenge) && (world->team[i].y>=player.y-(cone_anfangsbreite+(((world->team[i].x-player.x)*(cone_endbreite-cone_anfangsbreite))/cone_laenge))) && (world->team[i].y<=player.y+(cone_anfangsbreite+(((world->team[i].x-player.x)*(cone_endbreite-cone_anfangsbreite))/(cone_laenge)))))
	{
	  if (world->team[i].x>best_player.x)
	    {
	      best_player=world->team[i];
	    }
	}
    }


  // steht dieser Spieler frei ?

  if (best_player.x>0)
    {
      for (int i=0;i<world->getNumberOfOpponents();i++)
	{
	  if ((world->opponent[i].x>=best_player.x-opp_rect_laenge/2) && (world->opponent[i].x<=best_player.x+opp_rect_laenge/2) && (world->opponent[i].y>=best_player.y-opp_rect_breite/2) && (world->opponent[i].y<=best_player.y+opp_rect_breite/2))
	    return 0;


	  if ((world->opponent[i].x>=player.x) && (world->opponent[i].x<=best_player.x) && (world->opponent[i].y>=(cone_opp_breite*-1)+player.y+((best_player.y-player.y)*(world->opponent[i].x-player.x))/(best_player.x-player.x)) && (world->opponent[i].y<=cone_opp_breite+player.y+((best_player.y-player.y)*(world->opponent[i].x-player.x))/(best_player.x-player.x)))
	    return 0;
	}
      return ((best_player.x-player.x)*10);
    }

  /*

    if (best_player.x>0)
    {
    for (int x=0;x<FIELD_SIZE_X;x++)
    {
    for (int y=0;y<FIELD_SIZE_Y;y++)
    {
    if ((x>=best_player.x-opp_rect_laenge/2) && (x<=best_player.x+opp_rect_laenge/2) && (y>=best_player.y-opp_rect_breite/2) && (y<=best_player.y+opp_rect_breite/2))
    fieldInfo[x][y]=500;
    
    
    if ((x>=player.x) && (x<=best_player.x) && (y>=(cone_opp_breite*-1)+player.y+((best_player.y-player.y)*(x-player.x))/(best_player.x-player.x)) && (y<=cone_opp_breite+player.y+((best_player.y-player.y)*(x-player.x))/(best_player.x-player.x)))
      fieldInfo[x][y]=FIELD_SIZE_Y0;
      
      }
      }
      }
      
  */

  return 0;
}



// diese Methode steuert das Torwartverhalten, fuer den Fall,dass dieser nicht den Ball hat


int* PotentialField::goalie_no_ball_action ()
{
  Aktion[0]=0;
  Aktion[1]=0;
  Aktion[2]=0;
  Aktion[3]=0;
  Aktion[4]=0;


  // Wenn der Torwart auf die Idee kommt, das Spielfeld zu verlassen, erzaehlen wir ihm hier,
  // dass er dableiben soll.

  if (world->ball.x==0)
    world->ball.x=(int)(0.05*FIELD_SIZE_X);


  if (world->ball.y<=0)
    world->ball.y=(int)(0.5*FIELD_SIZE_Y);

  Point zielpunkt = Torwart_Ball_Schnittpunkt();
  if ( (abs(world->self.x - zielpunkt.x)<=(int)(0.04*FIELD_SIZE_X)) && (abs(world->self.y - zielpunkt.y)<=(int)(0.02*FIELD_SIZE_Y)) && world->ball.x<(int)(0.25*FIELD_SIZE_X) && (world->ball.y>(int)(0.25*FIELD_SIZE_Y)) && (world->ball.y<(int)(0.75*FIELD_SIZE_Y)))
    {
      Aktion[0]=world->ball.x;
      Aktion[1]=world->ball.y;
      return Aktion;
    }

  Aktion[0]=zielpunkt.x;
  Aktion[1]=zielpunkt.y;

  return Aktion;

}


// In dieser Methode werden die Bewertungen gesetzt, die aufgrund der Anwesenheit eines
// Spielers entstehen.


void PotentialField::SetPlayerEvaluation(const BasicObject &opp, int Gewichtung, bool Gegner)
{
  // wir rechnen nicht mit der aktuellen Position des Spielers, sondern mit seiner
  // Laufrichtung. Also mit dem Punkt in dem er vermutlich im naechsten Zyklus sein wird.

  // Log::debug << "SetPlayerValue" << endl;

  //Point p = getAusrichtung(opp);

  int x = opp.x;
  int y = opp.y;
  /*
    if ((my_Mannschaftsteil<3) && (Gegner))
    {
    x = x + (world->ball.x-opp.x)/10;
    y = y + (world->ball.y-opp.y)/10;
    }
  */

  if ((my_Mannschaftsteil==0) && (opp.x!=world->self.x) && (world->playMode==cmu::PM_My_Goal_Kick) && (!Gegner) && (Anzahl_Spieler_in_Rechteck(1,opp.y-15,opp.x+3,opp.y+15,true)==0))
    {
      Log::debug << "Spieler mit der Nummer " << opp.x << " " << opp.y << endl;
      Gewichtung=Gewichtung*50;
    }
 


  if (((opp.y>world->self.y>2) && (world->ball.x>(int)(0.2*FIELD_SIZE_X))) || ((world->ball.x<=(int)(0.2*FIELD_SIZE_X)) && (opp.x<(int)(0.22*FIELD_SIZE_X)) && (x>(int)(0.1*FIELD_SIZE_X))))
    {
      
      if ((cmu::Mem->MyNumber == 6) && (abs(world->self.y-opp.y)<9))
	manndeckung = true;
      
      if (((cmu::Mem->MyNumber == 4) || (cmu::Mem->MyNumber == 5))  && (abs(world->self.y-opp.y)>7))
	manndeckung = true;

      if (((cmu::Mem->MyNumber == 2) || (cmu::Mem->MyNumber == 3))  && (abs(world->self.y-opp.y)>8))
	manndeckung = true;
    }
  

      

  if ((my_Mannschaftsteil==1) && (!world->ballpossessing))
    {
      x = opp.x - (int)(0.02*FIELD_SIZE_X);

      if ((opp.y<(int)(0.65*FIELD_SIZE_Y)) && (world->ball.y>(int)(0.65*FIELD_SIZE_Y)))
	y = opp.y+(int)(0.02*FIELD_SIZE_Y);
      if ((opp.y>(int)(0.35*FIELD_SIZE_Y)) && (world->ball.y<(int)(0.35*FIELD_SIZE_Y)))
	y = opp.y-(int)(0.02*FIELD_SIZE_Y);
    }




  if (opp.y>(int)(0.75*FIELD_SIZE_Y))
    y = opp.y-(int)(0.02*FIELD_SIZE_Y);

  if (opp.y<(int)(0.25*FIELD_SIZE_Y))
    y = opp.y+(int)(0.02*FIELD_SIZE_Y);


  if (x<0)
    x=0;

  if (y<0)
    y=0;

  // die Variable Reichweite gibt an auf wieviele Felder,in jeder Himmelsrichtung, sich die
  // Anwesenheit eines Spielers auswirkt.

  int Reichweite = (int)(0.08*FIELD_SIZE_X);
  

  if ((!world->ballpossessing) && (Gegner == true) && (world->ball.x<(int)(0.4*FIELD_SIZE_X)))
    {
      Reichweite = (int)(0.05*FIELD_SIZE_X);
    }
  
if ((!world->ballpossessing) && (Gegner == false) && (world->ball.x<(int)(0.4*FIELD_SIZE_X)))
    {
      Reichweite = (int)(0.1*FIELD_SIZE_X);
    }



  if ((world->ballpossessing) && (world->ball.x<(int)(0.3*FIELD_SIZE_X)) && (opp.x < (int)(0.3*FIELD_SIZE_X)) && (Gegner==true))
    {
      Reichweite = (int)(0.1*FIELD_SIZE_X);
    }


  // Wenn wir den Ball haben,soll ein kleinerer Bereich um den Mitspieler bewertet werden.
  // (Grund: Passgenauigkeit)

  if ((Gegner==false) && (world->ballpossessing==true))
    {
      Reichweite = (int)(0.06*FIELD_SIZE_X);
    }



  int max = 100;
  int dynReichweite = Reichweite;
  int Versatz=0;
  int eval=0;



  // Hinter den Gegnern wird noch zusaetzlich ein Bereich mit sehr negativen Werten gesetzt
  // Dies geschieht mit set_cone
  


  if ((Gegner) && (world->ballpossessing) && (abs(world->self.x-world->ball.x)<(int)(0.5*FIELD_SIZE_Y)) && (abs(world->self.y-world->ball.y)<(int)(0.5*FIELD_SIZE_Y)))
    {
       set_cone(world->ball.x,world->ball.y,opp);
    }

 // fuer jeden Mitspieler wird dein Suboptimalitatesbonus berechnet und zur bisherigen
 // Bewertung hinzuaddiert.




 if ((!Gegner) && (world->ballpossessing) && (get_Suboptimalitaet_Bonus(opp)>0))
    {
      //Log::print("set_player_value");
      set_Player_value(opp.x,opp.y,get_Suboptimalitaet_Bonus(opp),false);
    }



 // hier geschieht nun die eigentliche Bewertung eines Spielers. Wir bewerten rautenfoermig
 // die Felder um einen Spieler, die engeren Kreis haben dabei eine hoehere Bewertung als
 // die weiteren.

 // Log::print("for-Schleife");

  for (int j=0;j<=Reichweite;j++)
    {
      Versatz = Reichweite-dynReichweite;
      //   Log::print("for-Schleife Reichweite");
      for	(int i=dynReichweite;i>=0;i--)
	{
	  eval = (max-((i+Versatz)*Reichweite))*Gewichtung;

	  if ((j==0) && (i==0))
	    {
	      set_Player_value(x,y, eval,Gegner);
	    }
	  if ((j==0) && (i>0))
	    {
	      if ((y+i)<FIELD_SIZE_Y)
		{
		  set_Player_value(x,y+i,eval,Gegner);
		}
	      if ((y-i)>=0)
		{
		  set_Player_value(x,y-i,eval,Gegner);
		}
	    }
	  if ((i==0) && (j>0))
	    {
	      if ((x+j)<FIELD_SIZE_X)
		{
		  set_Player_value(x+j,y,eval,Gegner);
		}
	      if ((x-j)>=0)
		{
		  set_Player_value(x-j,y,eval,Gegner);
		}
	    }
	
	  if ((j>0) && (i>0))
	    {
	      if (((x+j)<FIELD_SIZE_X) && ((y+i)<FIELD_SIZE_Y))
		{
		  set_Player_value(x+j,y+i,eval,Gegner);					
		}
	      if (((x+j)<FIELD_SIZE_X) && ((y-i)>=0))
		{
		  set_Player_value(x+j,y-i,eval,Gegner);
		}	
	      if (((x-j)>=0) && ((y+i)<FIELD_SIZE_Y))
		{
		  set_Player_value(x-j,y+i,eval,Gegner);				
		}
	      if (((x-j)>=0) && ((y-i)>=0))
		{
		  set_Player_value(x-j,y-i,eval,Gegner);
		}
	    }
	}
      dynReichweite--;
    }
 
}


/** *************************************************************
 * hier beginnt das    G E T R I C K S E   **********************
 * fr den Torwart und fr Situationen, wo das Potentialfeld ****
 * schweigen soll und wir einfach die Richtung vorgeben. ********
 * **************************************************************
 * Vorschlag meinerseits:
 * Wir erzeugen eine Aktionsklasse jeweils fr Spieler und Torwart.
 * Meinetwegen PlayerMidLevelBehaviour und GoalieMidLevelBehaviour.
 *
 * Dort tut man dann die "Tricks" hinein - also alles, was nichts
 * mit dem Potentialfeld zu tun hat.
 *
 *--s-n-i-p----->
<pre>
abstract class MidLevelBehaviour {
  BTeamAction * action; // low level behaviour component
public:
  MidLevelBehaviour(BTeamAction *a) : action(a) {}
  bool behave() = 0;
}

class PlayerMidLevelBehaviour : public MidLevelBehaviour {

  // hier stnden die ganzen Hilfsmethoden fr die Tricks


public:

  PlayerMidLevelBehaviour(BTeamAction *a) : MidLevelBehaviour(a) {}

  bool behave() {
    // knnte so aussehn:

    if  (world->closestPlayerToBall && (!cmu::Mem->BallKickable()) && (my_Mannschaftsteil>0)) {
      action->doGetBall(NULL);
      return true; // true soll besagen: habe etwas gemacht.
    }

    // hier wrden weitere bedingungen folgen, weitere Methoden aufgerufen etc.
    // jeweils mit return true, wie oben

    return false;
    // wenn er hier hin kommt, kann er keine aktion ausgefhrt haben
    // also geben wir false zurck. der aufrufer (BTeamAction) kann dann so etwas
    // machen:
    // if (!midLevelBehaviour.behave()) {
    //    runPotentialField blabla
    //    fhre Action aus
    // }

  }
}
</pre>
   <-s-n-i-p------
*/
bool PotentialField::getQuicklyEvaluatedAction(int* &pAction) {
  //

  static bool moved = false;
  static int shotcount = 0;

  if (world->playMode == cmu::PM_Their_Kick_Off)
  {
    kick_time=0;
    pAction = NULL;
    return true;
  }

  if (!world->isMyStandardSituation())
    kick_time=0;

 if (world->playMode==cmu::PM_My_Goal_Kick)
   {
     if (my_Mannschaftsteil==0)
       world->closestPlayerToBall=true;

     else
       world->closestPlayerToBall=false;

   }

 //if  (world->closestPlayerToBall && (!cmu::Mem->BallKickable()) && (my_Mannschaftsteil>0))
 // {
 // Log::info << "Potentialfield::getEvaluatedAction(): closest player and !kickable" << endl;
 
 //   pAction = getAction(world->ball.x,world->ball.y);
 //return true;
 // }
 
 if ((my_Mannschaftsteil==0) && (world->ball.x<(int)(0.2*FIELD_SIZE_X)) && (world->ball.y>(int)(0.25*FIELD_SIZE_Y)) && (world->ball.y<(int)(0.75*FIELD_SIZE_Y)) && (!cmu::Mem->BallCatchable()) && (!cmu::Mem->BallKickable()))
   {
     // Log::info << "Potentialfield::getEvaluatedAction(): Torwart get ball" << endl;
     pAction = getAction(world->ball.x,world->ball.y);
     return true;
   }
 
 // Wenn der Spieler, fuer den die Bewertung durchgefuehrt wird, der Torwart ist,
 // und er nicht in Ballbesitz ist, wird die entsprechende Methode aufgerufen.
 
 // Ist der Torwart im Ballbesitz (Abstoss oder Abschlag) wird er als Feldspieler
 // behandelt. Sein spezielles Verhalten, wird in diesem Fall nur durch seine
 // Parameter gesteuert.
 /*
 if ((world->closestPlayerToBall) && (world->isMyStandardSituation()) && kick_time<15 )
   {
     Log::debug << "Standardsituation " << endl;
     Log::debug << "Kick time : " << kick_time << endl;
     Log::debug << "World->ballpossessing " << world->ballpossessing << endl;
     
     kick_time++;
     // Log::info << "Potentialfield::getEvaluatedAction(): Kick time :" << kick_time << "Playmode : " << cmu::Mem->PlayMode  << endl;
     if ((kick_time==15) && (world->playMode==cmu::PM_My_Goalie_Free_Kick) && (my_Mannschaftsteil==0))
       {
	 // Log::info << "Potentialfield::getEvaluatedAction():  GOALKEEPER MOVE_ACTION" << endl;
	 pAction = getAction(-1,-1);
	 return true;
       }

     pAction = NULL;
     return true;
   }
 */

 if ((world->playMode==cmu::PM_My_Goalie_Free_Kick) && (my_Mannschaftsteil==0) && !moved)
   {
     // Log::info << "Potentialfield::getEvaluatedAction():  GOALKEEPER MOVE_ACTION" << endl;
     if (shotcount == 0) 
       pAction = getAction(-1,-1);

     if (shotcount > 2) {
       moved = true;
       shotcount = 0;
     } else
       shotcount++;
     
     return true;
   }
 
 if (world->playMode==cmu::PM_My_Goalie_Free_Kick) moved = false;
 
 if ((my_Mannschaftsteil==0) && (!cmu::Mem->BallCatchable()) && (!cmu::Mem->BallKickable()))
   {
     // Log::info << "Potentialfield::getEvaluatedAction(): goalie no ball action" << endl;
     pAction = goalie_no_ball_action();
     return true;
   }
 

 

 if ((my_Mannschaftsteil==0)  && (cmu::Mem->BallCatchable()))
   {
     cmu::goalie_catch(cmu::Mem->BallAngleFromBody());
     catched=true;
     // Log::info << "catch_ball ausgefuehrt" << endl;
     pAction = NULL;
     return true;
   }

 if (catched)
     {
       catched = false;
     }

 return false;
}

void PotentialField::clearFieldValues() {



  //
 for (int x=0;x<FIELD_SIZE_X;x++)
    {
      for(int y=0;y<FIELD_SIZE_Y;y++)
	{
	  fieldInfo[x][y]=0;
	  Mitspieler_bew[x][y]=0;
	}
    }
}

bool PotentialField::isAllowedToQuickEvaluate() {
  return allowedToQuickEvaluate;
}
void PotentialField::setAllowedToQuickEvaluate(bool qe) {
  allowedToQuickEvaluate = qe;
}

void PotentialField::applyBlur() {
  
  int vRad = 2;
  int hRad = 2;

  int vWeight = vRad * 2 +1;
  int vHeight = hRad * 2 +1;

  int x,y,temp_y1,temp_y2,temp_x1,temp_x2;
  int i;
  
  // blur pixels horizontally

  for (x=x_min; x <= x_max; x++) {
    
    int sum = 0;
    y = y_min;
    
    // calculate sum for first pixel(s) in row
    for (i=-vRad;i<=vRad;i++) {
      temp_y1 = y-1+i;
      
      if ((temp_y1 >= y_min) && (temp_y1 <= y_max))
	sum += fieldInfo[x][temp_y1];
    }
    
    // for every pixel, add one value to the right and
    // subtract one value from the left of the current
    // blur region
    // then set current pixel to average of blur region
    for (y=y_min;y <= y_max; y++) {
      temp_y1 = y+vRad;
      temp_y2 = y-vRad-1;
      
      if (temp_y1 <= y_max)
	sum += (fieldInfo[x][temp_y1]);
      if (temp_y2 >= y_min)
	sum -= (fieldInfo[x][temp_y2]);

      fieldInfo[x][y]= (int)(sum/vWeight);
    }
  }
  
  // blur pixels vertically, same algorithm as above
  // just for columns

  for (y=y_min; y <= y_max; y++) {
    
    int sum = 0;
    x = x_min;
    
    for (i=-hRad;i<=hRad;i++) {
      temp_x1 = x-1+i;
      
      if ((temp_x1 >= x_min) && (temp_x1 <= x_max))
	sum += fieldInfo[temp_x1][y];
    }
    
    for (x=x_min;x <= x_max; x++) {
      temp_x1 = x+hRad;
      temp_x2 = x-hRad-1;
      
      if (temp_x1 <= x_max)
	sum += (fieldInfo[temp_x1][y]);
      if (temp_x2 >= x_min)
	sum -= (fieldInfo[temp_x2][y]);

      fieldInfo[x][y]= (int)(sum/vHeight);
    }
  }
  
}
  

void PotentialField::prepareFields() {

  // Feld glaetten
  applyBlur();
  
}

list<Action *> * PotentialField::buildListOfPossibleActions() {
  
  // erstmal nicht ...
  prepareFields();
  list<Action *> * actions = new list<Action *>;

  // hier wird der Punkt mit der hoechsten Bewertung ermittelt

  //  int pred,succ;

  for (int y=y_min;y<y_max;y++)
    {
      for(int x=x_min;x<x_max;x++)
	{
	  if (lokales_Maximum(pred_horizontal(x,y,x_min),fieldInfo[x][y],succ_horizontal(x,y,x_max)))
	    {
	      if (lokales_Maximum(pred_vertikal(x,y,y_min),fieldInfo[x][y],succ_vertikal(x,y,y_max)))
		{
		  if (lokales_Maximum(pred_diagonal_oben_unten(x,y,x_min,y_min),fieldInfo[x][y],succ_diagonal_oben_unten(x,y,x_max,y_max)))
		    {
		      if (lokales_Maximum(pred_diagonal_unten_oben(x,y,x_min,y_max),fieldInfo[x][y],succ_diagonal_unten_oben(x,y,x_max,y_min)))
			{
			  if (actions->size()==0)
			    {
			      actions->push_back(new Action( getAction( x , y ) ) );
			    }
			  else
			    {
			      Action * tempActionObj = *actions->begin();
			      list<Action*>::iterator endIterator = actions->end();
			      
			      for (list<Action*>::iterator iter = actions->begin(); iter!=endIterator; iter++)
				{
				  
				  tempActionObj = *iter;
				  if (fieldInfo[x][y] > fieldInfo[tempActionObj->pf_x][tempActionObj->pf_y])  
				    {
				      int * pfActionArray = getAction( x , y );
				      Action * tmpAction = new Action( pfActionArray ); 
				      actions->insert( iter, tmpAction );
				      break;
				    } 
				}
			      if (fieldInfo[x][y] <= fieldInfo[tempActionObj->pf_x][tempActionObj->pf_y])  
				{
				  actions->push_back(new Action( getAction( x , y ) ) );
				}
			    }
			  
			}
		    }
		}
	    }
	}
    }
  //  Log::debug << "Groesse der Liste der lokalen Maxima" << actions->size() << endl;
  
  return actions;
}

  
int * PotentialField::findBestAction() {

  int bestFI = 10000000; // maximaler Wert fuer die Felder, drueber sollte kein Wert kommen.
  int * action = NULL;
  
  for (int c=0; c<1; c++) {
    
    xbest = x_min;
    ybest = y_min;
    
    for (int x=x_min;x<x_max;x++)
      {
	for(int y=y_min;y<y_max;y++)
	  {
	    
	    if (( fieldInfo[x][y] > fieldInfo[xbest][ybest] ) &&
		( fieldInfo[x][y] < bestFI ))
	      {
		xbest  = x;
		ybest  = y;
	      }
	  }
      }

    bestFI = fieldInfo[xbest][ybest];
    action = getAction(xbest,ybest); // die auszufuehrende Aktion wird berechnet ...
  }

  return action;
  
}

void PotentialField::evaluatePlayers() {
  
  //
 int evalOpponent = 0;
 int evalTeam = 0;



  
 if ((abs(world->self.x-world->ball.x)<(int)(0.5*FIELD_SIZE_X)) && (abs(world->self.y-world->ball.y)<(int)(0.5*FIELD_SIZE_Y)))
   {
     if (world->teamBallPossession) //... und unser Team im Ballbesitz ist ...
       {
	 if ((my_Mannschaftsteil>1) | (world->ballpossessing))
	   {
	     
	     for(int i=0;i<world->getNumberOfOpponents();i++) // werden zunaechst mal alle Gegner mit
	       {				       // der entsprechenden Prioritaet bewertet
		 if (world->opponent[i].isValid())
		   {
		     
		     if ((world->ballpossessing) && (world->ball.x<(int)(0.3*FIELD_SIZE_X)) && (world->opponent[i].x< 0.3*FIELD_SIZE_X))
		       SetPlayerEvaluation(world->opponent[i],mit_ball_Gegnerprioritaet*2,true);
		     
		     else
		       SetPlayerEvaluation(world->opponent[i],mit_ball_Gegnerprioritaet,true);
		   }
	       }
	     
	     
	     for (int i=1;i<world->getNumberOfTeammates();i++)   // dann alle Mitspieler
	       {
		 if (world->team[i].isValid()) {
		   if (world->ballpossessing)		 // bei pers. Ballbesitz ist die Prioritaet
		     SetPlayerEvaluation(world->team[i],mit_ball_Mitspielerprioritaet,false);
		   else // eine andere als bei Mitspielerballbesitz
		     {
		       SetPlayerEvaluation(world->team[i],teammate_Mitspielerprioritaet,false);
		     }
		   evalTeam++;
		 }
	       }
	   }
	 
	 
	 
	 
	 if (world->ballpossessing)		      // wenn der Spieler den Ball hat, muss er auch sich
	   SetPlayerEvaluation(world->self,mit_ball_Mitspielerprioritaet,false); // selbst bewerten.
       }
     
     else		     // wenn der Gegner im Ballbesitz ist ....
       {
	 for(int i=0;i<world->getNumberOfOpponents();i++) // werden die Gegner entsprechend bewertet
	   {
	     if (world->opponent[i].isValid())
	       {
		 if ((my_Mannschaftsteil==1) && (world->ball.x<0.35*FIELD_SIZE_X) && (world->opponent[i].x<0.35*FIELD_SIZE_X))
		   {
		      SetPlayerEvaluation(world->opponent[i],ohne_ball_Gegnerprioritaet*3,true);
		      evalOpponent++;
		   }
		 else
		   {
		     SetPlayerEvaluation(world->opponent[i],ohne_ball_Gegnerprioritaet,true);
		     evalOpponent++;
		   }
		 
	       }
	   }
	 for(int i=1;i<world->getNumberOfTeammates();i++)	   // und die Mitspieler
	   {
	     if (world->team[i].isValid())
	       { if ((my_Mannschaftsteil==1) && (world->ball.x<0.4*FIELD_SIZE_X))
		 {
		   SetPlayerEvaluation(world->team[i],ohne_ball_Mitspielerprioritaet*4,false);
		   evalTeam++;
		 } 
	       else 
		 {
		   SetPlayerEvaluation(world->team[i],ohne_ball_Mitspielerprioritaet,false);
		   evalTeam++;
		 }
	       }
	   }
       }
   }
}


void PotentialField::evaluateFields() {
  
  //
  int Orientierungsx = 0;

  // der x-Wert des Orientierungspunktes wird berechnet

  if ((my_Mannschaftsteil == 1) && (!world->isMyStandardSituation()))
    {
      Orientierungsx = offsideLineX();
    }
  else {
    if (world->teamBallPossession)
      Orientierungsx=ball_orientierung(world->teamBallInMannschaftsteil);
    else
      Orientierungsx=ball_orientierung(world->oppBallInMannschaftsteil);
  }
  
  
  // Log::info << "komplettes Raster" << endl;
  // alle Felder des Rasters werden nacheinander durchlaufen und bewertet

  x_min = 0;
  x_max = FIELD_SIZE_X-1;
  y_min = 0;
  y_max = FIELD_SIZE_Y-1;

  

  for (int x=x_min;x<x_max;x++)
    {
      for(int y=y_min;y<y_max;y++)
	{

	  // wenn das Team in Ballbesitz ist und der Ball in der Naehe ist, wird
	  // ball_posession aufgerufen ( entweder zum Passen oder zum Freilaufen)

	  if ((world->teamBallPossession) && (abs(world->self.x-world->ball.x)<(int)(0.5*FIELD_SIZE_X)) && (abs(world->self.y-world->ball.y)<(int)(0.5*FIELD_SIZE_Y)) && ((my_Mannschaftsteil>1) | (world->ballpossessing)))
	    {
	      fieldInfo[x][y]=fieldInfo[x][y]+ball_posession(x,y);
	    }

	  // wenn der Spieler nicht persoenlich im Ballbesitz ist, muss die entsprechende
	  // Methode (Bewegung zum Orientierungspunkt) aufgerufen.


	  if (!world->ballpossessing)
	    { 
	      fieldInfo[x][y]=fieldInfo[x][y]+no_ball_posession(x,y,Orientierungsx);
	    }


	  // Anmerkung: Fuer den Fall, dass ein Mitspieler im Ballbesitz ist, ruft der
	  // Spieler sowohl ball_posession als auch no_ball_posession auf.
	  // Der Grund dafuer ist, er soll sich einerseits so bewegen, dass der Ballfuehrende
	  // einen guten Pass spielen kann ( ball_posession ) aber sich auch zu seinem
	  // Orientierungspunkt bewegen ( no_ball_posession).


	}
    }  

  
  Log::debug << "Orientierung : " << Orientierungsx << "," << Orientierungsy << endl;
  
}

void PotentialField::initializeCalculation() {
  //

  // setze arrays auf 0 zurueck
  clearFieldValues();
 
  x_min = 0;
  x_max = FIELD_SIZE_X-1;
  y_min = 0;
  y_max = FIELD_SIZE_Y-1;

  
}


list<Action *> * PotentialField::getListOfEvaluatedActions() {
  //
  
  
  initializeCalculation();
  
  if (isAllowedToQuickEvaluate()) {
    int * retAction = NULL;

    if (getQuicklyEvaluatedAction(retAction)) {
      if (retAction == NULL) return NULL;
      else {
	
	list<Action *> * retList = new list<Action*>;
	retList->push_back( new Action( retAction ) );
	return retList;
      }
    }
  }
  // Spielerbewertungen
  evaluatePlayers(); // BUMM
  evaluateFields();

  // hier wird die Action mit der hoechsten Bewertung ermittelt
  //  Log::debug << "ListAction" << endl;

  list<Action*> * retAction;
  if (world->ballpossessing)

    retAction = buildListOfPossibleActions();

  else {

    int * rArray = findBestAction();

    if (rArray == NULL) retAction = NULL;
    else {
      retAction = new list<Action*>;
      retAction->push_back( new Action( rArray ) );
    }

  }

  // Torwart reset
  if (kick_time>14)
    {
      kick_time=0;
      world->ballpossessing = false;
    }

  return retAction;
}



/** diese Methode koordiniert die gesamte Bewertung des Potentialfeldes.
    Uebergeben bekommt sie den Ausschnitt des Potentialfeldes, dass zu bewerten ist.
    */
int * PotentialField::getEvaluatedAction()
{
  
  initializeCalculation();

  if (isAllowedToQuickEvaluate()) {
    int * retAction = NULL;

    if (getQuicklyEvaluatedAction(retAction)) {
      return retAction;
    }
  }

  // Spielerbewertungen  
  evaluatePlayers();
  evaluateFields();

  // hier wird die Action mit der hoechsten Bewertung ermittelt
  int * retAction = findBestAction();

  // Torwart reset
  if (kick_time>14)
    {
      kick_time=0;
      world->ballpossessing = false;
    }

  return retAction;
  
}


/*
 * $Log: PotentialField.cc,v $
 * Revision 1.105  2002/04/13 07:59:17  jens
 * German Open 2002 Edition
 *
 * Revision 1.104  2002/04/09 17:07:54  seekamp
 * kleine Korrekturen
 *
 * Revision 1.103  2002/04/08 15:49:54  seekamp
 * kleinere Verbesserungen
 *
 * Revision 1.102  2002/04/08 13:28:06  seekamp
 * Aktionsausfuehrung fuer Manndecker wieder Staminschonender implementiert
 *
 * Revision 1.101  2002/04/05 14:56:55  seekamp
 * In AttackBehaviour das Laufen zum Zielpunkt eines Steilpasses zielstrebiger gestaltet.
 *
 * Revision 1.100  2002/04/05 08:40:57  seekamp
 * Wenn Ball in eigenem Viertel, dann sollen alle Aktionen der Abwehrspieler ausgefuehrt werden
 *
 * Revision 1.99  2002/04/04 15:54:07  seekamp
 * kleinere Veraenderungen am Attack und Shot Behaviour zudem Libero wieder eingefuehrt und Aussenverteidiger bei gegnerischen Angriffen ueber die gegenueberliegende Seite Richtung Mitte gezogen.
 *
 * Revision 1.98  2002/04/02 15:58:11  fastjack
 * Various changes. Torwart Abschlag Bugfix. kleinere unbedeutendere Korrekturen.
 *
 * Revision 1.97  2002/04/02 15:52:49  seekamp
 * Positionsfindung der Abwehrspieler besser auf Abseitsfalle und Viererkette eingestellt.
 *
 * Revision 1.96  2002/04/02 10:03:43  fastjack
 * created
 *
 * Revision 1.95  2002/04/01 16:00:37  seekamp
 * Kick-Ins werden nicht mehr direkt ins Aus geschossen.
 *
 * Revision 1.94  2002/04/01 15:57:12  fastjack
 * world.update wird nicht mehr im PotentialField aufgerufen. Grund: mehr Flexibilitaet. AttackBehaviour und BTeamAction von World entkoppelt.
 *
 * Revision 1.93  2002/04/01 14:56:48  seekamp
 * Verhalten bei Standardsituationen (eigene und gegnerische) verbessert.
 *
 * Revision 1.92  2002/03/28 16:19:45  seekamp
 * Anderes Verhalten vor Standardsituationen: es wird zunaechst 10 Zyklen gewartet, dann laeuft der ballnaechste Spieler zum Ball und schiesst direkt.
 *
 * Revision 1.91  2002/03/26 17:56:22  fastjack
 * Performance Optimierungen.
 *
 * Revision 1.90  2002/03/26 17:32:11  seekamp
 * Es muessten jetzt Steilpaesse gespielt werden, konnte allerdings noch nicht getestet werden.
 *
 * Revision 1.89  2002/03/25 17:32:21  seekamp
 * Testlaeufe
 *
 * Revision 1.88  2002/03/25 16:14:07  fastjack
 * Merged & added Behaviour classes for offensive behaviour
 *
 * Revision 1.87  2002/03/25 15:26:41  seekamp
 * Situation in der ein Steilpass in die Spitze gespielt werden kann, wird erkannt.
 *
 * Revision 1.86  2002/03/22 11:18:45  seekamp
 * neue Aufstellung
 *
 * Revision 1.85  2002/03/18 17:13:02  fastjack
 * Absturzursache im GouraudFiller behoben.
 *
 * Revision 1.84  2002/03/18 15:53:43  seekamp
 * Abseitsfalle wiedereingefuehrt - Spielgeschehen nach vorne verlagert
 *
 * Revision 1.83  2002/03/15 14:54:37  jens
 * Den Lernalgo weiter implementiert. Fehler ausgemerzt. Theoretisch lauffaehig.
 *
 * Revision 1.82  2002/03/15 13:56:01  seekamp
 * interception-Point veraendert
 *
 * Revision 1.81  2002/03/15 13:26:01  fastjack
 * Ausgaben entfernt / dem Gouraud Kerl mehr Genauigkeit verschafft und einen boesen BUG entfernt
 *
 * Revision 1.80  2002/03/14 17:43:16  seekamp
 * Fehlersuch im cone und bei der Aktionswahl
 *
 * Revision 1.79  2002/03/12 17:03:40  seekamp
 * Liste der Aktionen sortiert und Fehler im cone beseitigt
 *
 * Revision 1.78  2002/03/12 09:28:32  fastjack
 * bugs fixed: code did not compile
 *
 * Revision 1.77  2002/03/11 16:24:08  seekamp
 * lokale Maxima fuer die besten Punkte implementiert
 *
 * Revision 1.76  2002/03/11 15:36:14  fastjack
 * debug log disabled
 *
 * Revision 1.75  2002/03/11 15:01:25  fastjack
 * Wieder umgebaut nach Liste-erzeugen
 *
 * Revision 1.74  2002/03/08 16:24:31  jens
 * Arbeiten beendet, die uns Potentialfeldszenen im Client parsen lassen und uns dann vollstaendige Potentialfelder genriert. Potentialfelder die generiert wurden und welche, die wir als Szene genommen haben (also die Feldwerte weglassen) stimmen nun ueberein. Rundungsfehler sind beseitigt. Somit sollte die Grundlage fuer die automatische Prioritaetenanpassung gelegt sein.
 *
 * Revision 1.73  2002/03/08 16:17:30  seekamp
 * cone-Erweiterung
 *
 * Revision 1.72  2002/03/08 12:58:00  fastjack
 * code wieder bereinigt
 *
 * Revision 1.71  2002/03/07 17:00:15  fastjack
 * Habe PotentialField so umgestellt, dass es wieder so funktioniert wie vor unserer Aenderung von gestern; Code in extra Methoden ausgelagert wegen uebersicht - und einen derzeit nicht aufgerufenen Glaettungsalgorithmus implementiert, muss noch getestet werden.
 *
 * Revision 1.70  2002/03/05 18:13:15  fastjack
 * Interception Methode noch etwas fertiger.
 *
 * Revision 1.69  2002/03/05 17:08:01  fastjack
 * Interception Methoden fast fertig
 *
 * Revision 1.68  2002/03/04 14:39:47  seekamp
 * PotentialField gibt jetzt eine Liste von Aktionen zurueck und nicht nur einen Int-Wert
 *
 * Revision 1.67  2002/03/01 12:56:42  seekamp
 * Abschlaege nicht mehr direkt zu den gegnerischen Stuermern
 *
 * Revision 1.66  2002/03/01 11:18:47  fastjack
 * GPL added
 *
 * Revision 1.65  2002/02/28 11:27:27  fastjack
 * Ausgaben entfernt
 *
 * Revision 1.64  2002/02/26 17:59:30  jens
 * weiter am parsen eines eigenen PF gearbeitet. Einbinden in das Weltmodell funzt noch nicht richtig
 *
 * Revision 1.63  2002/02/25 18:06:38  seekamp
 * Interc.-Point - Verfolgung verbessert
 *
 * Revision 1.62  2002/02/21 17:24:58  seekamp
 * cone-Groesse veraendert
 *
 * Revision 1.61  2002/02/19 16:43:04  seekamp
 * blabla :-D
 *
 * Revision 1.60  2002/02/18 17:37:17  seekamp
 * Fehler im cone behoben
 *
 * Revision 1.59  2002/02/15 17:45:35  fastjack
 * PotentialField vorbereitet fuer Automatisierung durch zukuenftige Lernmethode, verschiedene Dinge aus World statt aus Mem geholt etc.
 *
 * Revision 1.58  2002/02/15 17:33:52  seekamp
 * neuen cone getestet - verbessertes Abwehrverhalten
 *
 * Revision 1.57  2002/02/15 13:51:09  fastjack
 * GouraudFiller repariert, fehlerhaften Algorithmus gefixt. Paar Kommentare entfernt.
 *
 * Revision 1.56  2002/02/14 19:39:54  fastjack
 * Gouraud Shader verbessert - sind noch Probleme drin leider.
 *
 * Revision 1.55  2002/02/14 19:05:41  seekamp
 * Abschlag variabel gestaltet. Abwehrstellungspiel veraendert. Schussart bei Standardsituationen ausgetauscht ( QuickestRelease)
 *
 * Revision 1.54  2002/02/12 14:31:28  seekamp
 * set_cone angepasst - noch nicht abgeschlossen - fliegt wohl raus
 *
 * Revision 1.53  2002/02/12 12:09:18  fastjack
 * Alternative Cone Methode ZUM TESTEN eingefuegt. Bei Nichtgefallen wieder entfernen :-D
 *
 * Revision 1.52  2002/02/11 17:04:15  seekamp
 * Fehlpassanalyse mit Wertanpassungen
 *
 * Revision 1.51  2002/02/10 14:29:09  fastjack
 * Kommentar hinzugefgt, unntiges include entfernt.
 *
 * Revision 1.50  2002/02/10 12:19:14  fastjack
 * Habe die Includes angepasst, damit die Header sich so wenig wie mglich
 * gegenseitig includen. Z.T. ersetzt durch forward Deklaration. getPFEntry Methode
 * aus dem PotentialField heraus geholt und in den PFieldLogger gepackt - ist dort
 * sinniger.
 *
 * Revision 1.49  2002/02/07 20:07:50  fastjack
 * merged
 *
 * Revision 1.48  2002/02/07 19:58:36  seekamp
 * neues Torwartverhalten
 *
 * Revision 1.47  2002/02/07 19:41:34  jens
 * Kommunikation auf Mitspieler und im Falle eines Schusses auch den Zielpunkt erweitert.
 *
 * Revision 1.46  2002/02/05 19:14:01  fastjack
 * Versucht, den Interception-Reflex zu optimieren.
 *
 * Revision 1.45  2002/02/05 18:22:23  seekamp
 * ne menge sachen gemacht
 *
 * Revision 1.44  2002/02/05 18:19:39  jens
 * Fixed the Parse Sound. Now we can hear the Ball and the opponents broadcasted by other players.
 *
 * Revision 1.43  2002/02/05 13:41:07  fastjack
 * gemerged
 *
 * Revision 1.42  2002/02/05 12:27:41  jens
 * Weltmodell update
 *
 * Revision 1.41  2002/02/05 12:10:27  seekamp
 * Abseitslinie nach hinten verschoben. Abwehrspieler laufen sich bei Teamballbesitz nicht mehr frei, sondern halten ihre Position. Insgesamt defensivere Ausrichtung.
 *
 * Revision 1.40  2002/02/04 19:44:09  seekamp
 * kleine Verbesserungen am Torschuss und an der Abseitsfalle
 *
 * Revision 1.39  2002/01/31 18:07:08  seekamp
 * Abseitsfalle eingebaut und Abseitsvermeidung fuer Stuermer implementiert.
 * Verschieden Fehler in der ball_possession ausgebessert.
 *
 * Revision 1.38  2002/01/30 13:05:30  seekamp
 * move-Befehl des Torwarts vorm Abschlag eingefuehrt
 *
 * Revision 1.37  2002/01/29 19:34:00  fastjack
 * Konflikte behoben.
 *
 * Revision 1.36  2002/01/29 19:18:51  seekamp
 * Verhalten fuer das Ausfuehren von Standardsituationen implementiert
 *
 * Revision 1.35  2002/01/29 12:06:37  fastjack
 * debugging in progress
 *
 * Revision 1.34  2002/01/29 11:23:06  seekamp
 * get_ball ersetzt durch go_to_point
 *
 * Revision 1.33  2002/01/29 10:57:59  jens
 * kick verbessert und pausen der Spieler teilweise behoben (scan field with body eingesetzt)
 *
 * Revision 1.32  2002/01/28 17:22:03  seekamp
 * Dem Torwart Abschlaege und Abstoesse beigebracht
 *
 * Revision 1.31  2002/01/28 02:13:50  fastjack
 * Added an intermediary World object which should guess positions when it is done. Not ready yet, WARNING - code may or may not work.
 *
 * Revision 1.30  2002/01/25 18:54:38  seekamp
 * Staminaverwaltung implementiert
 *
 * Revision 1.28  2002/01/24 10:45:30  seekamp
 * Wir sehen den Ball jetzt 5 Zyklen in der Zukunft...
 *
 * Revision 1.27  2002/01/22 19:05:10  seekamp
 * Torwart verbessert
 *
 * Revision 1.26  2002/01/22 09:35:47  seekamp
 * Torwart und Feldgroesse
 *
 * Revision 1.25  2002/01/21 12:08:36  fastjack
 * PFieldLogger: das Format so geaendert, dass der PFViewer die PFelder auch parsen kann. Deshalb die UNUM erstmal wieder entfernt
 *
 * Revision 1.24  2002/01/18 20:11:21  fastjack
 * Das Logging von Potentialfeldern fertig gestellt. Das Logging ist auch
 * ein-/ausschaltbar ( PFieldLogger::getInstance().setEnabled(true) ).
 *
 * Revision 1.23  2002/01/18 19:49:29  seekamp
 * Prioritaeten werden durch Andys FileReader aus individuellen Spielertextdateien eingelesen.
 *
 * Revision 1.22  2002/01/17 19:11:40  fastjack
 * kleinere Aenderungen bzgl. pfield logging eingefuegt. dummy methode in PotentialField eingefuegt ...
 *
 * Revision 1.21  2002/01/17 18:15:22  seekamp
 * Verschiedene Methoden in Potentialfield und BTeamAction veraendert, mit dem
 * Ergebnis, dass der ballnaechste Spieler zum Ball laeuft und einen Pass spielt.
 * (mehr oder weniger)
 *
 * Revision 1.20  2002/01/15 21:50:28  seekamp
 * Fehler in der Bewertungsfunktion ausgemerzt.
 * Individuelles Spielverhalten getestet.
 *
 * Revision 1.19  2002/01/15 16:42:37  seekamp
 * Fehler in der Potentialfield.cc und in BTeamAction.cc beseitigt und Werte
 * veraendert in Poentialfield.hh
 *
 * Revision 1.18  2002/01/15 09:31:21  fastjack
 * Alten CMU Parser statt RCCParser fuer see Messages wieder eingebaut.
 *
 * Revision 1.17  2002/01/10 19:02:26  jens
 * tries to find further bugs. The actual bugs are: the Ballposition seems to be invalid sometimes. We dont know where the ballposition becomes set and why we have an invalid position although we have a valid position IN the Worldmodel of CMU. The second bug we tried to fix is an invalid position of player. It seems that only the last player has an invalid position.
 *
 * Revision 1.16  2002/01/08 17:20:41  jens
 * eliminated two major bugs which caused the clients to exit. Did it with the use of some small hacks and a lot of bugfinding. Three Flags(two for the close goals and one for a flag which CMU doesnt understands) where omitted, but can be reintegrated easily(Visual Handler).
 *
 * Revision 1.15  2002/01/07 18:50:05  jens
 * Further tryings to get rid of those Bugs. Found two sources, eliminated one
 * Actual Bug is located in the cenvesrion from RCC-Flags to CMU-Markers.
 *
 * Revision 1.14  2002/01/03 17:48:02  fastjack
 * einige abstuerze behoben.
 *
 * Revision 1.13  2002/01/03 01:04:36  fastjack
 * Parser verwendet fuer hear Messages wieder die originale CMU Methode. Ausserdem habe ich einige weitere Ausgaben in das PotentialField getan, um herauszufinden, wo er aussteigt. Dann habe ich das Timing so geHACKT, dass es immer true gibt, ausser es ist geblockt. Debugging necessary.
 *
 * Revision 1.12  2001/12/28 17:12:37  fastjack
 * joah
 *
 * Revision 1.11  2001/12/28 16:10:30  fastjack
 * verschiedenste bugfixes in allen bereichen
 *
 * Revision 1.10  2001/12/21 17:08:05  fastjack
 * Implemented rest of lowlevel functionality, if it really works cannot be tested, yet.
 *
 * Revision 1.9  2001/12/20 18:16:24  jens
 * eleminated different compile errors and started to implement simple actions
 *
 * Revision 1.8  2001/12/18 18:43:11  fastjack
 * Compiled nicht. Vorsicht, habe eine Menge auskommentiert. Timing z.B., und alles wo cmu:: drin vorkommt. Kruzifix!
 *
 * Revision 1.7  2001/12/18 17:05:34  fastjack
 * 1. Haben die Methoden zum Einlesen des CMU Weltmodells fertiggestellt.
 * 2. Verschiedene Variablen entfernt, Code restrukturiert.
 * 3. MessageParser Interface ueberarbeitet. ( Methoden setzen die Werte nicht,
 * sondern aendern sie entsprechend des Parameters )
 *
 * Es bedanken sich fuer die Aufmerksamkeit,
 *
 * Herr Seekamp und Herr Stephan
 *
 * Revision 1.6  2001/12/17 17:27:10  seekamp
 *
 *
 * gesamte Klasse kommentiert und dokumentiert.
 *
 * Revision 1.5  2001/12/14 20:41:39  fastjack
 * PotentialField neu geschrieben auf Basis von Matthias' Code
 *
 *
 */
