/*****************************************************************************
 * $RCSfile: PotentialField.hh,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: seekamp $
 * $Date: 2002/04/08 13:28:06 $
 * $Revision: 1.60 $
 *****************************************************************************/


#ifndef POTENTIALFIELD_HH
#define POTENTIALFIELD_HH

// #include <fstream>
#include "PFieldLogger.hh"
#include "gouraud.hh"
#include "BTeamTypes.hh"
#include <list>

// forward declarations ...
struct PFEntry;
struct Point;
class World;
class BasicObject;

namespace cmu
{
  class PlayerObject;
  class Ray;
  class Vector;
  
}

struct Action;

class PotentialField {

  public:
  static const int FIELD_SIZE_X = 90;
  static const int FIELD_SIZE_Y = 60;
  static const float ORIGINAL_FIELD_SIZE_X = 52.5;
  static const float ORIGINAL_FIELD_SIZE_Y = 34;
  static const int Dribbelbereich = (int)(0.04*FIELD_SIZE_X);
  static const int min_Abwehr_x = (int)(0.11*FIELD_SIZE_X);
  static const int max_Abwehr_x= (int)(0.6*FIELD_SIZE_X);
  static const int min_Mittelfeld_x =(int)(0.20*FIELD_SIZE_X);
  static const int max_Mittelfeld_x = (int)(0.85*FIELD_SIZE_X);
  static const int min_Sturm_x = (int)(0.44*FIELD_SIZE_X);
  static const int max_Sturm_x= (int)(0.93*FIELD_SIZE_X);
  static const int selfEcken_x=(int)(0.22*FIELD_SIZE_X);
  static const int selfEcken_y =(int)(0.16*FIELD_SIZE_Y);
  static const int Ausrichtung = (int)(0.04*FIELD_SIZE_X);
  static const int linkerPfosten_y = (int)(0.44*FIELD_SIZE_Y);
  static const int rechterPfosten_y = (int)(0.56*FIELD_SIZE_Y);
  static const int Abseitslinie = (int)(0.4*FIELD_SIZE_X);

  

  static const int Positionsbewertung = 100;
  static const int Anti_Abseitsfallen_Wert = - 100000;
  static const int Abseits_Wert = - 100000;



  // Definition des Suboptimalitaetstrapezes
  static const int cone_laenge = (int)(0.05*FIELD_SIZE_X);
  static const int cone_anfangsgroesse = (int)(0.08*FIELD_SIZE_X);
  static const int cone_anfangsbreite = (int)(0.03*FIELD_SIZE_Y);
  static const int cone_endbreite = (int)(0.06*FIELD_SIZE_Y);
  static const int opp_rect_laenge = (int)(0.1*FIELD_SIZE_X);
  static const int opp_rect_breite = (int)(0.2*FIELD_SIZE_X);
  static const int cone_opp_breite = (int)(0.06*FIELD_SIZE_X);
  

  static const int goalie_cone_anfangsbreite=(int)(0.03*FIELD_SIZE_Y);
  static const int goalie_cone_endbreite=(int)(0.06*FIELD_SIZE_Y);
  
  static const double MAX_STEILPASS_ZIELLINIE = 50.0;


  int fieldInfo[FIELD_SIZE_X][FIELD_SIZE_Y];
  // kommt jetzt aus World!
  // static const int numberOfOpponents=11;
  // static const int numberOfTeammates=11;
  // Bewertungen
  int Staminaprioritaet;
  int Torschussbewertung;
  int Torschussprioritaet;
  int Rueckpassprioritaet;
  int Entfernungswert;
  int Entfernungsprioritaet;
  int my_Mannschaftsteil;
  int Ballbewertung;
  int Ballpriority;
  int Taktik;
  int selfGrund_x;
  int selfGrund_y;
  int Positionsprioritaet;
  int mit_ball_Gegnerprioritaet;
  int ohne_ball_Gegnerprioritaet;
  int mit_ball_Mitspielerprioritaet;
  int ohne_ball_Mitspielerprioritaet;
  int teammate_Mitspielerprioritaet;
  int x_min;
  int y_min;
  int x_max;
  int y_max;
  int xbest;
  int ybest;
  bool catched;
  int kick_time;
  bool manndeckung;
    // Werte aus dem WModell

  /* ab jetzt aus dem World Objekt
  int team_Ball_in_Mannschaftsteil;
  int opp_Ball_in_Mannschaftsteil;
  bool team_ball_posession;
  bool Ballposession;
  bool closest_Player_to_ball;
  int ball_x;
  int ball_y;
  int myPos_x;
  int myPos_y;
  int my_stamina;

  typedef BasicObject Teamm[11];
  typedef BasicObject Opponent[11];

  Teamm Teammates;
  Opponent Opponents;
  BasicObject self;
  */
  int Mitspieler_bew[FIELD_SIZE_X][FIELD_SIZE_Y];
  int Aktion[5];
  int Orientierungsy,Orientierungsx;

  bool allowedToQuickEvaluate;

  World * world;
  GouraudFiller * filler;
  private:
/*  void setDefaultPriorities() {

    Staminaprioritaet = 0;//5
    Torschussbewertung = 0;//80
    Torschussprioritaet = 0;//50
    Rueckpasspriority = 0;//7
    Entfernungswert = 0;//10
    Entfernungsprioritaet = 0;//40
    my_Mannschaftsteil = 0;//1
    Ballbewertung = 0;//100
    Ballpriority = 0;//100
    // Positionsbewertung = 50;
    Positionsbewertung =100;//100
    Taktik = 0;//20
    selfGrund_x = 0;
    selfGrund_y = 0;
    Positionsprioritaet= 0;//100
    mit_ball_Gegnerprioritaet = 0;//-13
    ohne_ball_Gegnerprioritaet = 0; //20
    mit_ball_Mitspielerprioritaet = 0;//11
    ohne_ball_Mitspielerprioritaet = 0;//-11
    teammate_Mitspielerprioritaet = 0 ;//-4
    opp_Ball_in_Mannschaftsteil= 2;
  } */

  public:


  PotentialField(World * w) : catched(false),kick_time(0),allowedToQuickEvaluate(true),world(w) {
    filler = new GouraudFiller((int*)fieldInfo,FIELD_SIZE_Y,FIELD_SIZE_X);
    filler->setFillMode(FM_REPLACE);
  };



  bool getQuicklyEvaluatedAction(int* &pAction);
  void initializeCalculation();
  int * getEvaluatedAction();
  list<Action *> * getListOfEvaluatedActions();
  void prepareFields();
  void applyBlur();
  void evaluatePlayers();
  void evaluateFields();
  int * findBestAction();
  list<Action *> * buildListOfPossibleActions();


  PFEntry * getPFEntry();

  private:
  bool isPlayModeCornerKick();
  

  bool lokales_Maximum(int a,int b,int c);
  int pred_horizontal(int x,int y,int xmin);
  int succ_horizontal(int x,int y,int xmax);
  int pred_vertikal(int x,int y,int ymin);
  int succ_vertikal(int x,int y,int ymax);
  int pred_diagonal_oben_unten(int x,int y,int xmin,int ymin);
  int succ_diagonal_oben_unten(int x,int y,int xmax,int ymax);
  int pred_diagonal_unten_oben(int x,int y,int xmin,int ymax);
  int succ_diagonal_unten_oben(int x,int y,int xmax,int ymin);
  double distance(int x1,int y1,int x2,int y2);
  double double_distance(double x1,double y1, double x2,double y2);
  int geraden_Schnittpunkt(double m, double a, double n, double b);
  int ball_orientierung_Zaehler(int min, int max );
  int ball_orientierung(int Mannschaftsteil);
  int no_ball_posession(int x,int y,int Orientierungsx);
  int ball_posession(int x, int y);
  int* getAction(int x,int y);
  void set_cone_Bewertung(int x, int y);
  void set_cone(int ballx,int bally, const BasicObject &opp);
  Point getAusrichtung(const BasicObject &opp);
  void set_Player_value(int x,int y, int eval, bool Gegner);
  int get_Suboptimalitaet_Bonus(const BasicObject &player);
  int* goalie_no_ball_action ();
  void SetPlayerEvaluation(const BasicObject &opp, int Gewichtung, bool Gegner);
  int Zeitpunkt_Bewertung();
  int Stamina_Bewertung();
  int Zielpunkt_Bewertung(int x,int y);
  int Aktions_Bewertung();
  bool Aktions_Ausfuehrung(int x,int y);
  int move_goalie();
  int Abseitsfalle(int x);
  bool closest_Player_to_goal();
  bool closest_Teammate_to_goal();
  int getXOrientationValue();
  int Anzahl_Spieler_in_Rechteck(int x,int y,int x2,int y2,bool Gegner);
  int y_Bewertung_goalie(bool links);
  int offsideLineX();
  Point Torwart_Ball_Schnittpunkt();
  void drawLine(cmu::Vector start,cmu::Vector end);
  void fillCircle(cmu::Vector center,double radius);
  bool manndeckerAktionsAusfuehrung();
    
  public:
  bool isAllowedToQuickEvaluate();
  void setAllowedToQuickEvaluate(bool qe);
  void clearFieldValues();
  static int translateX(float x);
  static int translateY(float y);
  static float translateToGlobalX(int x);
  static float translateToGlobalY(int y);

  void changeStaminaprioritaet(int v) {
    Staminaprioritaet += v;
  }

  void changeTorschussbewertung(int v) {
    Torschussbewertung += v;
  }

  void changeTorschussprioritaet(int v) {
    Torschussprioritaet += v;
  }

  void changeRueckpasspriority(int v) {
    Rueckpassprioritaet += v;
  }

  void changeEntfernungswert(int v) {
    Entfernungswert += v;
  }

  void changeEntfernungsprioritaet(int v) {
    Entfernungsprioritaet += v;
  }

  void changeBallbewertung(int v) {
    Ballbewertung += v;
  }

  void changeBallpriority(int v) {
    Ballpriority += v;
  }

  void changeMyMannschaftsteil(int v) {
    my_Mannschaftsteil +=v;
  }

  void changeTaktik(int v) {
    Taktik += v;
  }

  void changeSelfGrundX(int v) {
    selfGrund_x += v;
    selfGrund_x=translateX((float)selfGrund_x);
  }

  void changeSelfGrundY(int v) {
    selfGrund_y += v;
    selfGrund_y=translateY((float)selfGrund_y);
  }

  void changePositionsprioritaet(int v) {
    Positionsprioritaet += v;
  }

  void changeGegnerprioritaetMitBall(int v) {
    mit_ball_Gegnerprioritaet += v;
  }

  void changeGegnerprioritaetOhneBall(int v) {
    ohne_ball_Gegnerprioritaet += v;
  }

  void changeMitspielerprioritaetMitBall(int v) {
    mit_ball_Mitspielerprioritaet += v;
  }

   void changeMitspielerprioritaetOhneBall(int v) {
    ohne_ball_Mitspielerprioritaet += v;
  }

   void changeMitspielerprioritaetTeammateMitBall(int v) {
    teammate_Mitspielerprioritaet += v;
  }


 int getStaminaprioritaet() {
    return Staminaprioritaet;
  }

  int getTorschussbewertung() {
    return Torschussbewertung ;
  }

  int getTorschussprioritaet() {
    return Torschussprioritaet ;
  }

  int getRueckpasspriority() {
    return Rueckpassprioritaet ;
  }

  int getEntfernungswert() {
    return Entfernungswert ;
  }

  int getEntfernungsprioritaet() {
    return Entfernungsprioritaet ;
  }

  int getBallbewertung() {
    return Ballbewertung ;
  }

  int getBallpriority() {
    return Ballpriority ;
  }

  int getMyMannschaftsteil(){
    return my_Mannschaftsteil;
  }

  int getTaktik() {
    return Taktik ;
  }

  int getSelfGrundX() {
    return selfGrund_x ;
  }

  int getSelfGrundY() {
    return selfGrund_y ;
  }

  int getPositionsprioritaet() {
    return Positionsprioritaet ;
  }

  int getGegnerprioritaetMitBall() {
    return mit_ball_Gegnerprioritaet ;
  }

  int getGegnerprioritaetOhneBall() {
    return ohne_ball_Gegnerprioritaet ;
  }

  int getMitspielerprioritaetMitBall() {
    return mit_ball_Mitspielerprioritaet ;
  }

   int getMitspielerprioritaetOhneBall() {
    return ohne_ball_Mitspielerprioritaet ;
  }

   int getMitspielerprioritaetTeammateMitBall() {
    return teammate_Mitspielerprioritaet ;
  }

  friend PFEntry * PFieldLogger::createEntryFromPotentialField(PotentialField * field);
};

#endif //POTENTIALFIELD_HH


/*
 * $Log: PotentialField.hh,v $
 * Revision 1.60  2002/04/08 13:28:06  seekamp
 * Aktionsausfuehrung fuer Manndecker wieder Staminschonender implementiert
 *
 * Revision 1.59  2002/04/02 15:52:49  seekamp
 * Positionsfindung der Abwehrspieler besser auf Abseitsfalle und Viererkette eingestellt.
 *
 * Revision 1.58  2002/04/01 15:57:13  fastjack
 * world.update wird nicht mehr im PotentialField aufgerufen. Grund: mehr Flexibilitaet. AttackBehaviour und BTeamAction von World entkoppelt.
 *
 * Revision 1.57  2002/03/26 17:32:11  seekamp
 * Es muessten jetzt Steilpaesse gespielt werden, konnte allerdings noch nicht getestet werden.
 *
 * Revision 1.56  2002/03/25 17:32:21  seekamp
 * Testlaeufe
 *
 * Revision 1.55  2002/03/25 15:26:41  seekamp
 * Situation in der ein Steilpass in die Spitze gespielt werden kann, wird erkannt.
 *
 * Revision 1.54  2002/03/18 17:13:03  fastjack
 * Absturzursache im GouraudFiller behoben.
 *
 * Revision 1.53  2002/03/18 15:53:43  seekamp
 * Abseitsfalle wiedereingefuehrt - Spielgeschehen nach vorne verlagert
 *
 * Revision 1.52  2002/03/14 17:24:50  jens
 * Grundlagen des Lernalgorithmusses implmentiert(aeussere Struktur). TODO: Vectorsortierung, Parameter alternieren, Parameterdatei abspeichern...
 *
 * Revision 1.51  2002/03/12 15:45:30  jens
 * Grundlage fuer das Lernen der Prioritaeten implementiert. Fehler dabei ausgemerzt und Algorithmus fuer das Lernen auf Papier konkretesiert.
 *
 * Revision 1.50  2002/03/11 16:24:08  seekamp
 * lokale Maxima fuer die besten Punkte implementiert
 *
 * Revision 1.49  2002/03/11 15:01:26  fastjack
 * Wieder umgebaut nach Liste-erzeugen
 *
 * Revision 1.48  2002/03/08 16:17:30  seekamp
 * cone-Erweiterung
 *
 * Revision 1.47  2002/03/08 12:58:00  fastjack
 * code wieder bereinigt
 *
 * Revision 1.46  2002/03/07 17:00:15  fastjack
 * Habe PotentialField so umgestellt, dass es wieder so funktioniert wie vor unserer Aenderung von gestern; Code in extra Methoden ausgelagert wegen uebersicht - und einen derzeit nicht aufgerufenen Glaettungsalgorithmus implementiert, muss noch getestet werden.
 *
 * Revision 1.45  2002/03/04 14:39:49  seekamp
 * PotentialField gibt jetzt eine Liste von Aktionen zurueck und nicht nur einen Int-Wert
 *
 * Revision 1.44  2002/03/01 11:18:47  fastjack
 * GPL added
 *
 * Revision 1.43  2002/02/26 17:59:30  jens
 * weiter am parsen eines eigenen PF gearbeitet. Einbinden in das Weltmodell funzt noch nicht richtig
 *
 * Revision 1.42  2002/02/21 17:24:58  seekamp
 * cone-Groesse veraendert
 *
 * Revision 1.41  2002/02/19 16:43:04  seekamp
 * blabla :-D
 *
 * Revision 1.40  2002/02/18 17:37:17  seekamp
 * Fehler im cone behoben
 *
 * Revision 1.39  2002/02/15 17:45:35  fastjack
 * PotentialField vorbereitet fuer Automatisierung durch zukuenftige Lernmethode, verschiedene Dinge aus World statt aus Mem geholt etc.
 *
 * Revision 1.38  2002/02/14 19:39:54  fastjack
 * Gouraud Shader verbessert - sind noch Probleme drin leider.
 *
 * Revision 1.37  2002/02/14 19:05:41  seekamp
 * Abschlag variabel gestaltet. Abwehrstellungspiel veraendert. Schussart bei Standardsituationen ausgetauscht ( QuickestRelease)
 *
 * Revision 1.36  2002/02/12 14:31:28  seekamp
 * set_cone angepasst - noch nicht abgeschlossen - fliegt wohl raus
 *
 * Revision 1.35  2002/02/12 12:09:18  fastjack
 * Alternative Cone Methode ZUM TESTEN eingefuegt. Bei Nichtgefallen wieder entfernen :-D
 *
 * Revision 1.34  2002/02/11 17:04:15  seekamp
 * Fehlpassanalyse mit Wertanpassungen
 *
 * Revision 1.33  2002/02/10 14:29:09  fastjack
 * Kommentar hinzugefgt, unntiges include entfernt.
 *
 * Revision 1.32  2002/02/10 12:19:14  fastjack
 * Habe die Includes angepasst, damit die Header sich so wenig wie mglich
 * gegenseitig includen. Z.T. ersetzt durch forward Deklaration. getPFEntry Methode
 * aus dem PotentialField heraus geholt und in den PFieldLogger gepackt - ist dort
 * sinniger.
 *
 * Revision 1.31  2002/02/07 20:07:50  fastjack
 * merged
 *
 * Revision 1.30  2002/02/07 19:58:36  seekamp
 * neues Torwartverhalten
 *
 * Revision 1.29  2002/02/05 18:22:23  seekamp
 * ne menge sachen gemacht
 *
 * Revision 1.28  2002/02/05 12:27:41  jens
 * Weltmodell update
 *
 * Revision 1.27  2002/02/05 12:10:27  seekamp
 * Abseitslinie nach hinten verschoben. Abwehrspieler laufen sich bei Teamballbesitz nicht mehr frei, sondern halten ihre Position. Insgesamt defensivere Ausrichtung.
 *
 * Revision 1.26  2002/02/04 19:44:09  seekamp
 * kleine Verbesserungen am Torschuss und an der Abseitsfalle
 *
 * Revision 1.25  2002/01/31 18:07:08  seekamp
 * Abseitsfalle eingebaut und Abseitsvermeidung fuer Stuermer implementiert.
 * Verschieden Fehler in der ball_possession ausgebessert.
 *
 * Revision 1.24  2002/01/30 13:05:32  seekamp
 * move-Befehl des Torwarts vorm Abschlag eingefuehrt
 *
 * Revision 1.23  2002/01/29 19:18:51  seekamp
 * Verhalten fuer das Ausfuehren von Standardsituationen implementiert
 *
 * Revision 1.22  2002/01/29 11:23:06  seekamp
 * get_ball ersetzt durch go_to_point
 *
 * Revision 1.21  2002/01/28 17:22:03  seekamp
 * Dem Torwart Abschlaege und Abstoesse beigebracht
 *
 * Revision 1.20  2002/01/28 02:13:50  fastjack
 * Added an intermediary World object which should guess positions when it is done. Not ready yet, WARNING - code may or may not work.
 *
 * Revision 1.19  2002/01/25 18:48:32  seekamp
 * Staminaverwaltung implementiert
 *
 * Revision 1.18  2002/01/21 17:39:44  seekamp
 * dynamisch anpassbare Rastergroesse implementiert
 *
 * Revision 1.17  2002/01/18 19:49:29  seekamp
 * Prioritaeten werden durch Andys FileReader aus individuellen Spielertextdateien eingelesen.
 *
 * Revision 1.16  2002/01/17 19:11:40  fastjack
 * kleinere Aenderungen bzgl. pfield logging eingefuegt. dummy methode in PotentialField eingefuegt ...
 *
 * Revision 1.15  2002/01/17 18:15:22  seekamp
 * Verschiedene Methoden in Potentialfield und BTeamAction veraendert, mit dem
 * Ergebnis, dass der ballnaechste Spieler zum Ball laeuft und einen Pass spielt.
 * (mehr oder weniger)
 *
 * Revision 1.14  2002/01/15 21:50:28  seekamp
 * Fehler in der Bewertungsfunktion ausgemerzt.
 * Individuelles Spielverhalten getestet.
 *
 * Revision 1.13  2002/01/15 16:42:38  seekamp
 * Fehler in der Potentialfield.cc und in BTeamAction.cc beseitigt und Werte
 * veraendert in Poentialfield.hh
 *
 * Revision 1.11  2002/01/15 09:31:22  fastjack
 * Alten CMU Parser statt RCCParser fuer see Messages wieder eingebaut.
 *
 * Revision 1.10  2002/01/07 18:50:06  jens
 * Further tryings to get rid of those Bugs. Found two sources, eliminated one
 * Actual Bug is located in the cenvesrion from RCC-Flags to CMU-Markers.
 *
 * Revision 1.9  2002/01/03 01:04:36  fastjack
 * Parser verwendet fuer hear Messages wieder die originale CMU Methode. Ausserdem habe ich einige weitere Ausgaben in das PotentialField getan, um herauszufinden, wo er aussteigt. Dann habe ich das Timing so geHACKT, dass es immer true gibt, ausser es ist geblockt. Debugging necessary.
 *
 * Revision 1.8  2001/12/21 17:08:06  fastjack
 * Implemented rest of lowlevel functionality, if it really works cannot be tested, yet.
 *
 * Revision 1.7  2001/12/20 18:16:24  jens
 * eleminated different compile errors and started to implement simple actions
 *
 * Revision 1.6  2001/12/18 18:43:11  fastjack
 * Compiled nicht. Vorsicht, habe eine Menge auskommentiert. Timing z.B., und alles wo cmu:: drin vorkommt. Kruzifix!
 *
 * Revision 1.5  2001/12/18 17:05:35  fastjack
 * 1. Haben die Methoden zum Einlesen des CMU Weltmodells fertiggestellt.
 * 2. Verschiedene Variablen entfernt, Code restrukturiert.
 * 3. MessageParser Interface ueberarbeitet. ( Methoden setzen die Werte nicht,
 * sondern aendern sie entsprechend des Parameters )
 *
 * Es bedanken sich fuer die Aufmerksamkeit,
 *
 * Herr Seekamp und Herr Stephan
 *
 * Revision 1.4  2001/12/14 20:41:39  fastjack
 * PotentialField neu geschrieben auf Basis von Matthias' Code
 *
 *
 */



